# !/bin/sh

# This script build the related Petri Net for all the distributed 
# application generation examples and stores the result in a 
# subdirectory of the current directory

# Build the tests

work_dir=`pwd`
script_dir=`dirname $0`; cd ${script_dir}; script_dir=`pwd`
cd ${work_dir}

SCENARIO_FILES="${script_dir}/bbs/scenario.aadl \
     ${script_dir}/bintree/scenario_1.aadl \
     ${script_dir}/bintree/scenario_2.aadl \
     ${script_dir}/man_in_the_middle/scenario.aadl \
     ${script_dir}/ring/scenario_1.aadl \
     ${script_dir}/ring/scenario_2.aadl \
     ${script_dir}/multiple_call_seq/scenario_1.aadl \
     ${script_dir}/multicast/scenario_void.aadl \
     ${script_dir}/multicast/scenario_std.aadl \
     ${script_dir}/multicast/scenario_seq.aadl"

for S in ${SCENARIO_FILES}; do
    ocarina.sh -n -s ${S}
done

# Check the Petri Net with Framekit

if [ "${PETRISCRIPT}" = "" ]
then
    echo "Set the PETRISCRIPT variable so that it refers to new_modular_service in FrameKit...";
    exit 1;
fi;

PETRI_CMD="-s -fromscratch -petriscript"

for S in ${SCENARIO_FILES}; do
    TEST_DIR="`head -1 ${S}`"
    ${PETRISCRIPT} ${PETRI_CMD} \
	./${TEST_DIR}/generated_final.psc \
	-store ./${TEST_DIR}/pn.cami
done

rm -f New_modular_services.* tmp_change_storage.* program_processed.petriscript FK_groups
