------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                  OCARINA.AADL.PARSER.PROPERTIES.VALUES                   --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2004-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package contains the functions that deal with the property
--  values parsing

package Ocarina.AADL.Parser.Properties.Values is

   function P_Multi_Valued_Property return Node_Id;
   --  Current token must be 'list'

   function P_Property_Constant
     (Identifier   : Node_Id;
      Property_Set : Node_Id)
     return Node_Id;
   --  Current token must be 'constant'

   function P_Property_Expression (Container : Node_Id) return Node_Id;

   function P_Property_Type_Declaration
     (Identifier   : Node_Id;
      Property_Set : Node_Id)
     return Node_Id;
   --  Current token must be 'type'

   function P_Single_Valued_Property return Node_Id;

end Ocarina.AADL.Parser.Properties.Values;
