------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--         O C A R I N A . A A D L . P R I N T E R . A N N E X E S          --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2005-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Namet;
with Output;

with Ocarina.Nodes;
with Ocarina.AADL.Printer.Identifiers;

package body Ocarina.AADL.Printer.Annexes is

   use Namet;
   use Output;
   use Ocarina.Nodes;
   use Ocarina.AADL.Printer.Identifiers;

   procedure Print_Annex_Content (Node : Node_Id);

   -------------------------
   -- Print_Annex_Content --
   -------------------------

   procedure Print_Annex_Content (Node : Node_Id) is
   begin
      Write_Name (Raw_Text (Node));
   end Print_Annex_Content;

   ---------------------------
   -- Print_Annex_Subclause --
   ---------------------------

   procedure Print_Annex_Subclause
     (Node    : Node_Id;
      Options : Output_Options)
   is
      pragma Unreferenced (Options);

      Content : constant Node_Id := Annex_Content (Node);
   begin
      Write_Indentation;
      Print_Token (T_Annex);
      Write_Space;

      Print_Identifier (Identifier (Node));
      Write_Space;

      Print_Token (T_Begin_Annex);

      if Present (Content) then
         Print_Annex_Content (Content);
      else
         Write_Eol;
      end if;

      Write_Indentation;
      Write_Indentation (-1);
      Print_Token (T_End_Annex);
      Print_Token (T_Semicolon);
   end Print_Annex_Subclause;

end Ocarina.AADL.Printer.Annexes;
