------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--              OCARINA.AADL.PRINTER.COMPONENTS.SUBCOMPONENTS               --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2005-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Output;

with Ocarina.Nodes;
with Ocarina.AADL.Printer.Components.Modes;
with Ocarina.AADL.Printer.Properties;
with Ocarina.AADL.Printer.Identifiers;

package body Ocarina.AADL.Printer.Components.Subcomponents is

   use Output;
   use Ocarina.Nodes;
   use Ocarina.AADL.Printer.Components;
   use Ocarina.AADL.Printer.Components.Modes;
   use Ocarina.AADL.Printer.Properties;
   use Ocarina.AADL.Printer.Identifiers;

   ------------------------
   -- Print_Subcomponent --
   ------------------------

   procedure Print_Subcomponent
     (Node    : Node_Id;
      Options : Output_Options)
   is
      Class_Ref     : constant Node_Id := Entity_Ref (Node);
      Subcomp_Modes : constant Node_Id := In_Modes (Node);
   begin
      Write_Indentation;
      Print_Item_Refined_To (Node);
      Write_Space;
      Print_Component_Category (Category (Node));

      if Present (Class_Ref) then
         Write_Space;
         Print_Entity_Reference (Class_Ref);
      end if;

      Print_Contained_Property_Associations
        (Ocarina.Nodes.Properties (Node), Options);

      if Present (Subcomp_Modes) then
         Write_Eol;
         Print_In_Modes (Subcomp_Modes, Options);
      end if;

      Print_Token (T_Semicolon);
      Write_Eol;
   end Print_Subcomponent;

end Ocarina.AADL.Printer.Components.Subcomponents;
