------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--      O C A R I N A . A A D L . P R I N T E R . N A M E S P A C E S       --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2004-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

package Ocarina.AADL.Printer.Namespaces is

   procedure Print_AADL_Specification
     (Node    : Node_Id;
      Options : Output_Options);
   --  Print the AADL source corresponding to the given AADL
   --  specification node.

   generic
      with function Is_Printable
        (Node      : Node_Id;
         Criterion : Node_Id)
        return Boolean;
      --  This is a general purpose comparison routine. The Criterion
      --  may not be necessary in some cases.

   procedure Print_Constrained_AADL_Specification
     (Node      : Node_Id;
      Criterion : Node_Id;
      Options   : Output_Options);
   --  Same as above but only prints the AADL declarations for which
   --  the given Is_Printable (<Node>, Criterion) is True.

   procedure Print_Package
     (Node    : Node_Id;
      Options : Output_Options);
   --  Print the AADL source correspodning to the given package
   --  specification node.

   generic
      with function Is_Printable
        (Node      : Node_Id;
         Criterion : Node_Id)
        return Boolean;
      --  This is a general purpose comparison routine. The Criterion
      --  may not be necessary in some cases.

   procedure Print_Constrained_Package
     (Node      : Node_Id;
      Criterion : Node_Id;
      Options   : Output_Options);
   --  Same as above but only prints the AADL declarations for which
   --  the given Is_Printable (<Node>, Criterion) is True.

   procedure Print_Property_Set
     (Node    : Node_Id;
      Options : Output_Options);
   --  Prints the AADL source corresponding to the given property set
   --  node.

   generic
      with function Is_Printable
        (Node      : Node_Id;
         Criterion : Node_Id)
        return Boolean;
      --  This is a general purpose comparison routine. The Criterion
      --  may not be necessary in some cases.

   procedure  Print_Constrained_Property_Set
     (Node      : Node_Id;
      Criterion : Node_Id;
      Options   : Output_Options);
   --  Same as above but only prints the AADL declarations for which
   --  the given Is_Printable (<Node>, Criterion) is True.

end Ocarina.AADL.Printer.Namespaces;
