------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--      O C A R I N A . A A D L . P R I N T E R . P R O P E R T I E S       --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

package Ocarina.AADL.Printer.Properties is

   procedure Print_Property_Association
     (Node      : Node_Id;
      Options   : Output_Options;
      Contained : Boolean        := False);
   --  If Contained is set to True, the statement will be
   --  indented. Set to False if the indentation is done by the
   --  calling procedure (this is the case for a contained property
   --  association).

   procedure Print_Contained_Property_Associations
     (List    : List_Id;
      Options : Output_Options);

   procedure Print_Property_Name_Declaration
     (Node    : Node_Id;
      Options : Output_Options);

   procedure Print_Property_Type_Declaration
     (Node    : Node_Id;
      Options : Output_Options);

   procedure Print_Constant_Property
     (Node    : Node_Id;
      Options : Output_Options);

end Ocarina.AADL.Printer.Properties;
