------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                O C A R I N A . C O N F I G U R A T I O N                 --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2006-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

package Ocarina.Configuration is

   function Data_Directory return String;
   --  Return the directory that contains the Ocarina data files.
   --  IMPORTANT: this function needs Ocarina to be installed using
   --  the classical way (./configure; make; make install). Otherwise,
   --  the environment variable 'OCARINA_PATH' has to be set. The
   --  'OCARINA_PATH' variable indicates the installation directory of
   --  Ocarina.

   procedure Init_Modules;
   procedure Reset_Modules;

   function Ocarina_Version return String;
   function Ocarina_SVN_Revision return String;
   function Ocarina_Last_Configure_Date return String;
   function Ocarina_Last_Configure_Year return String;
   --  Version control routines

private

   function GNU_Make_Cmd return String;
   --  Return the command used to invoke the GNU make on the current
   --  platform.

end Ocarina.Configuration;
