------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                 OCARINA.ENTITIES.COMPONENTS.CONNECTIONS                  --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2004-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package provides functions to build connection within
--  component implementations.

with Types;

package Ocarina.Entities.Components.Connections is

   type Connection_Type is
     (CT_Data,
      CT_Data_Delayed,
      CT_Event,
      CT_Event_Data,
      CT_Port_Group,
      CT_Parameter,
      CT_Access_Bus,
      CT_Access_Data,
      CT_Access_Subprogram);
   --  CT_Access_Subprogram is not part of AADL 1.0

   subtype Port_Connection_Type is Connection_Type
     range CT_Data .. CT_Event_Data;

   function Get_Category_Of_Connection
     (Connection : Types.Node_Id)
     return Connection_Type;

end Ocarina.Entities.Components.Connections;
