------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--          O C A R I N A . E N T I T I E S . C O M P O N E N T S           --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2004-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Ocarina.Nodes;

package body Ocarina.Entities.Components is

   -------------------------------
   -- Get_Category_Of_Component --
   -------------------------------

   function Get_Category_Of_Component
     (Component : Types.Node_Id)
     return Component_Category
   is
      use Types;
      use Ocarina.Nodes;

      pragma Assert
        (Kind (Component) = K_Component_Implementation
         or else Kind (Component) = K_Component_Type
         or else Kind (Component) = K_Component_Instance
         or else Kind (Component) = K_Subcomponent_Instance);
   begin
      if Kind (Component) = K_Component_Implementation
        or else Kind (Component) = K_Component_Type
      then
         return Component_Category'Val (Category (Component));
      elsif Kind (Component) = K_Subcomponent_Instance then
         if Present
           (Corresponding_Declaration
            (Corresponding_Instance
             (Component)))
         then
            return Component_Category'Val
              (Category
               (Corresponding_Declaration
                (Corresponding_Instance
                 (Component))));
         else
            return CC_Unknown;
         end if;
      else
         if Present (Corresponding_Declaration (Component)) then
            return Component_Category'Val
              (Category
               (Corresponding_Declaration
                (Component)));
         else
            return CC_Unknown;
         end if;
      end if;
   end Get_Category_Of_Component;

end Ocarina.Entities.Components;
