------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--          O C A R I N A . E N T I T I E S . N A M E S P A C E S           --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2004-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Ocarina.Nodes;

package body Ocarina.Entities.Namespaces is

   ---------------------------------------------------
   -- Package_Has_Public_Declarations_Or_Properties --
   ---------------------------------------------------

   function Package_Has_Public_Declarations_Or_Properties
     (Pack : Types.Node_Id)
     return Boolean
   is
      use Ocarina.Nodes;
      use Types;

      pragma Assert (Pack /= No_Node
                     and then Kind (Pack) = K_Package_Specification);
   begin
      return Has_Public_Part (Pack);
   end Package_Has_Public_Declarations_Or_Properties;

   ----------------------------------------------------
   -- Package_Has_Private_Declarations_Or_Properties --
   ----------------------------------------------------

   function Package_Has_Private_Declarations_Or_Properties
     (Pack : Types.Node_Id)
     return Boolean
   is
      use Ocarina.Nodes;
      use Types;

      pragma Assert (Pack /= No_Node
                     and then Kind (Pack) = K_Package_Specification);
   begin
      return Has_Private_Part (Pack);
   end Package_Has_Private_Declarations_Or_Properties;

end Ocarina.Entities.Namespaces;
