------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--              OCARINA.EXPANDER.COMPONENTS.SUBPROGRAM_CALLS                --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

package Ocarina.Expander.Components.Subprogram_Calls is

   function Expand_Call_Sequence
     (Instance_Root : Node_Id;
      Call_Sequence : Node_Id)
     return Node_Id;

   function Expand_Subprogram_Call
     (Instance_Root   : Node_Id;
      Subprogram_Call : Node_Id)
     return Node_Id;

   function Duplicate_Subprogram_Call_Instance
     (Instance_Root : Node_Id;
      Call_Instance : Node_Id)
     return Node_Id;
   --  Create a new instance of the corresponding subprogram. This is
   --  useful if some properties apply to a given subprogram call.

end Ocarina.Expander.Components.Subprogram_Calls;
