------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                     O C A R I N A . M E S S A G E S                      --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Output;

package body Ocarina.Messages is

   --------------------------------
   -- Display_No_Suitable_Parser --
   --------------------------------

   procedure Display_No_Suitable_Parser (Filename : String) is
      use Output;
   begin
      Set_Standard_Error;
      Write_Line
        (Filename
         & " : no suitable parser for this file");
      Set_Standard_Output;
   end Display_No_Suitable_Parser;

   -----------------------------------
   -- Display_Parse_Additional_File --
   -----------------------------------

   procedure Display_Parse_Additional_File (Filename, Entity_Name : String) is
      use Output;
   begin
      Set_Standard_Error;
      Write_Line ("Importing "
                  & Filename
                  & " for the missing declaration "
                  & Entity_Name);
      Set_Standard_Output;
   end Display_Parse_Additional_File;

   --------------------------------
   -- Display_Cannot_Create_File --
   --------------------------------

   procedure Display_Cannot_Create_File (Filename : String) is
      use Output;
   begin
      Set_Standard_Error;
      Write_Line
        (Filename
         & " : cannot create file");
      Set_Standard_Output;
   end Display_Cannot_Create_File;

end Ocarina.Messages;
