------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                        O C A R I N A . N O D E S                         --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                 Copyright (C) 2007, GET-Telecom Paris.                   --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

pragma Style_Checks ("NM32766");

--  This file has been generated automatically by `mknodes'. Do not
--  hand modify this file since your changes will be overridden.

with GNAT.Table;
pragma Warnings (Off);
with Locations; use Locations;
with Types;     use Types;
pragma Warnings (On);

package Ocarina.Nodes is

   type Node_Kind is
     (K_Node_Id,
      K_List_Id,
      K_Invalid_Node,
      K_Annotated_Node,
      K_Annotation_Item,
      K_Node_Container,
      K_Scope_Definition,
      K_Identifier,
      K_AADL_Entity,
      K_Named_AADL_Entity,
      K_AADL_Declaration,
      K_Scoped_Name,
      K_Entity_Reference,
      K_Pair_Of_Entity_References,
      K_Identifiers_List,
      K_AADL_Specification,
      K_AADL_Declarations_List,
      K_Package_Specification,
      K_Component_Category,
      K_Component_Type,
      K_Component_Implementation,
      K_Contained_Entity,
      K_Subclause,
      K_Feature,
      K_Refinable_Feature,
      K_Port_Spec,
      K_Port_Group_Spec,
      K_Subprogram_Spec,
      K_Parameter,
      K_Subcomponent_Access,
      K_Flow_Spec,
      K_Mode,
      K_Mode_Transition,
      K_In_Modes,
      K_Flow_Implementation,
      K_End_To_End_Flow_Spec,
      K_Flow_Implementation_Refinement,
      K_End_To_End_Flow_Refinement,
      K_Subprogram_Call,
      K_Subprogram_Call_Sequence,
      K_Subcomponent,
      K_Port_Group_Type,
      K_Connection,
      K_Property_Set,
      K_Property_Type,
      K_Property_Type_Declaration,
      K_Single_Valued_Property,
      K_Multi_Valued_Property,
      K_Constant_Property_Declaration,
      K_Property_Value,
      K_Property_Name_Declaration,
      K_Property_List_Value,
      K_In_Binding,
      K_Property_Association,
      K_Literal,
      K_Signed_AADLNumber,
      K_Not_Boolean_Term,
      K_And_Boolean_Term,
      K_Or_Boolean_Term,
      K_Parenthesis_Boolean_Term,
      K_Minus_Numeric_Term,
      K_Property_Term,
      K_Number_Range_Term,
      K_Component_Classifier_Term,
      K_Reference_Term,
      K_Boolean_Type,
      K_String_Type,
      K_Real_Type,
      K_Integer_Type,
      K_Enumeration_Type,
      K_Number_Range,
      K_Unit_Definition,
      K_Units_Type,
      K_Range_Type,
      K_Classifier_Type,
      K_Referable_Element_Category,
      K_Reference_Type,
      K_Unique_Property_Type_Identifier,
      K_Property_Owner_Category,
      K_Applies_To,
      K_Unique_Property_Const_Identifier,
      K_Annex_Content,
      K_Annex_Subclause,
      K_Annex_Library,
      K_Architecture_Instance,
      K_Entity_Instance,
      K_Entity_Reference_Instance,
      K_Declaration_Instance,
      K_Component_Instance,
      K_Subcomponent_Instance,
      K_Namespace_Instance,
      K_Feature_Instance,
      K_Port_Spec_Instance,
      K_Port_Group_Spec_Instance,
      K_Subprogram_Spec_Instance,
      K_Parameter_Instance,
      K_Subcomponent_Access_Instance,
      K_Call_Sequence_Instance,
      K_Call_Instance,
      K_Mode_Instance,
      K_Mode_Transition_Instance,
      K_Connection_Instance,
      K_Virtual_Connection);

   --
   --  Node_Id
   --
   --    Next_Node                : Node_Id
   --

   --
   --  List_Id
   --
   --    First_Node               : Node_Id
   --    Last_Node                : Node_Id
   --

   --
   --  Invalid_Node
   --
   --    Next_Node                : Node_Id
   --

   procedure W_Invalid_Node (N : Node_Id);

   --
   --  Annotated_Node
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --

   procedure W_Annotated_Node (N : Node_Id);

   --
   --  Annotation_Item
   --
   --    Next_Node                : Node_Id
   --    Annotation_Node          : Node_Id
   --    Annotation_Name          : Name_Id
   --    Annotation_Info          : Node_Id
   --

   procedure W_Annotation_Item (N : Node_Id);

   --
   --  Node_Container
   --
   --    Next_Node                : Node_Id
   --    Item                     : Node_Id
   --    Extra_Item               : Node_Id
   --

   procedure W_Node_Container (N : Node_Id);

   --
   --  Scope_Definition
   --
   --    Next_Node                : Node_Id
   --    Scoped_Identifiers       : Node_Id
   --    Corresponding_Entity     : Node_Id
   --

   procedure W_Scope_Definition (N : Node_Id);

   --
   --  Identifier
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Name                     : Name_Id
   --    Display_Name             : Name_Id
   --    Corresponding_Entity     : Node_Id
   --    Scope_Entity             : Node_Id
   --    Potential_Scope          : Node_Id
   --    Homonym                  : Node_Id
   --    Visible                  : Boolean
   --    Backend_Node             : Node_Id
   --

   procedure W_Identifier (N : Node_Id);

   --
   --  AADL_Entity
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --

   procedure W_AADL_Entity (N : Node_Id);

   --
   --  Named_AADL_Entity
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --

   procedure W_Named_AADL_Entity (N : Node_Id);

   --
   --  AADL_Declaration
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Entity_Scope             : Node_Id
   --    Property_Scope           : Node_Id
   --    Is_Private               : Boolean
   --    First_Visited_Node       : Node_Id
   --    Namespace                : Node_Id
   --    Default_Instance         : Node_Id
   --

   procedure W_AADL_Declaration (N : Node_Id);

   --
   --  Scoped_Name
   --
   --    Next_Node                : Node_Id
   --    Identifier               : Node_Id
   --    Reference                : Node_Id
   --    Parent_Entity            : Node_Id
   --    Depth                    : Int
   --    Next_Scoped_Name         : Node_Id
   --

   procedure W_Scoped_Name (N : Node_Id);

   --
   --  Entity_Reference
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Path                     : List_Id
   --    Namespace_Path           : List_Id
   --    Namespace_Identifier     : Node_Id
   --    Full_Identifier          : Node_Id
   --    Entity                   : Node_Id
   --

   procedure W_Entity_Reference (N : Node_Id);

   --
   --  Pair_Of_Entity_References
   --
   --    Next_Node                : Node_Id
   --    First_Reference          : Node_Id
   --    Second_Reference         : Node_Id
   --

   procedure W_Pair_Of_Entity_References (N : Node_Id);

   --
   --  Identifiers_List
   --
   --    First_Node               : Node_Id
   --    Last_Node                : Node_Id
   --

   procedure W_Identifiers_List (N : List_Id);

   --
   --  AADL_Specification
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Declarations             : List_Id
   --    Entity_Scope             : Node_Id
   --

   procedure W_AADL_Specification (N : Node_Id);

   --
   --  AADL_Declarations_List
   --
   --    First_Node               : Node_Id
   --    Last_Node                : Node_Id
   --

   procedure W_AADL_Declarations_List (N : List_Id);

   --
   --  Package_Specification
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Has_Private_Part         : Boolean
   --    Has_Public_Part          : Boolean
   --    Entity_Scope             : Node_Id
   --    Declarations             : List_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --

   procedure W_Package_Specification (N : Node_Id);

   --
   --  Component_Category
   --
   --    Next_Node                : Node_Id
   --    Category                 : Byte
   --

   procedure W_Component_Category (N : Node_Id);

   --
   --  Component_Type
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Entity_Scope             : Node_Id
   --    Property_Scope           : Node_Id
   --    Is_Private               : Boolean
   --    First_Visited_Node       : Node_Id
   --    Namespace                : Node_Id
   --    Default_Instance         : Node_Id
   --    Category                 : Byte
   --    Features                 : List_Id
   --    Flows                    : List_Id
   --    Properties               : List_Id
   --    Annexes                  : List_Id
   --    Parent                   : Node_Id
   --    Instances                : List_Id
   --

   procedure W_Component_Type (N : Node_Id);

   --
   --  Component_Implementation
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Entity_Scope             : Node_Id
   --    Property_Scope           : Node_Id
   --    Is_Private               : Boolean
   --    First_Visited_Node       : Node_Id
   --    Namespace                : Node_Id
   --    Default_Instance         : Node_Id
   --    Component_Type_Identifier: Node_Id
   --    Category                 : Byte
   --    Refines_Type             : List_Id
   --    Subcomponents            : List_Id
   --    Calls                    : List_Id
   --    Connections              : List_Id
   --    Flows                    : List_Id
   --    Modes                    : List_Id
   --    Properties               : List_Id
   --    Annexes                  : List_Id
   --    Parent                   : Node_Id
   --    Instances                : List_Id
   --

   procedure W_Component_Implementation (N : Node_Id);

   --
   --  Contained_Entity
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --

   procedure W_Contained_Entity (N : Node_Id);

   --
   --  Subclause
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --

   procedure W_Subclause (N : Node_Id);

   --
   --  Feature
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --

   procedure W_Feature (N : Node_Id);

   --
   --  Refinable_Feature
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --

   procedure W_Refinable_Feature (N : Node_Id);

   --
   --  Port_Spec
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --    Is_In                    : Boolean
   --    Is_Out                   : Boolean
   --    Is_Event                 : Boolean
   --    Is_Data                  : Boolean
   --

   procedure W_Port_Spec (N : Node_Id);

   --
   --  Port_Group_Spec
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --

   procedure W_Port_Group_Spec (N : Node_Id);

   --
   --  Subprogram_Spec
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --    Is_Server                : Boolean
   --

   procedure W_Subprogram_Spec (N : Node_Id);

   --
   --  Parameter
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --    Is_In                    : Boolean
   --    Is_Out                   : Boolean
   --

   procedure W_Parameter (N : Node_Id);

   --
   --  Subcomponent_Access
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --    Is_Provided              : Boolean
   --    Subcomponent_Category    : Byte
   --

   procedure W_Subcomponent_Access (N : Node_Id);

   --
   --  Flow_Spec
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --    Category                 : Byte
   --    Source_Flow              : Node_Id
   --    Sink_Flow                : Node_Id
   --

   procedure W_Flow_Spec (N : Node_Id);

   --
   --  Mode
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --    Is_Initial               : Boolean
   --

   procedure W_Mode (N : Node_Id);

   --
   --  Mode_Transition
   --
   --    Next_Node                : Node_Id
   --    Source_Modes             : List_Id
   --    Unique_Ports             : List_Id
   --    Destination_Mode         : Node_Id
   --    Container_Component      : Node_Id
   --

   procedure W_Mode_Transition (N : Node_Id);

   --
   --  In_Modes
   --
   --    Next_Node                : Node_Id
   --    Modes                    : List_Id
   --

   procedure W_In_Modes (N : Node_Id);

   --
   --  Flow_Implementation
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Category                 : Byte
   --    Connections              : List_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_Flow_Implementation (N : Node_Id);

   --
   --  End_To_End_Flow_Spec
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Connections              : List_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_End_To_End_Flow_Spec (N : Node_Id);

   --
   --  Flow_Implementation_Refinement
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Category                 : Byte
   --    In_Modes                 : Node_Id
   --

   procedure W_Flow_Implementation_Refinement (N : Node_Id);

   --
   --  End_To_End_Flow_Refinement
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_End_To_End_Flow_Refinement (N : Node_Id);

   --
   --  Subprogram_Call
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    In_Modes                 : Node_Id
   --    Parent_Sequence          : Node_Id
   --

   procedure W_Subprogram_Call (N : Node_Id);

   --
   --  Subprogram_Call_Sequence
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Subprogram_Calls         : List_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_Subprogram_Call_Sequence (N : Node_Id);

   --
   --  Subcomponent
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Implicit_Inverse      : Boolean
   --    Inversed_Entity          : Node_Id
   --    Is_Refinement            : Boolean
   --    Category                 : Byte
   --    In_Modes                 : Node_Id
   --

   procedure W_Subcomponent (N : Node_Id);

   --
   --  Port_Group_Type
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Entity_Scope             : Node_Id
   --    Property_Scope           : Node_Id
   --    Is_Private               : Boolean
   --    First_Visited_Node       : Node_Id
   --    Namespace                : Node_Id
   --    Default_Instance         : Node_Id
   --    Features                 : List_Id
   --    Inverse_Of               : Node_Id
   --    Properties               : List_Id
   --    Annexes                  : List_Id
   --    Parent                   : Node_Id
   --

   procedure W_Port_Group_Type (N : Node_Id);

   --
   --  Connection
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Property_Scope           : Node_Id
   --    Properties               : List_Id
   --    Entity_Ref               : Node_Id
   --    Is_Refinement            : Boolean
   --    Category                 : Byte
   --    Source                   : Node_Id
   --    Destination              : Node_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_Connection (N : Node_Id);

   --
   --  Property_Set
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Declarations             : List_Id
   --    Entity_Scope             : Node_Id
   --    Property_Set_Context     : Node_Id
   --

   procedure W_Property_Set (N : Node_Id);

   --
   --  Property_Type
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Is_List                  : Boolean
   --    Property_Type_Designator : Node_Id
   --    Expanded_Type_Designator : Node_Id
   --

   procedure W_Property_Type (N : Node_Id);

   --
   --  Property_Type_Declaration
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Property_Type_Designator : Node_Id
   --

   procedure W_Property_Type_Declaration (N : Node_Id);

   --
   --  Single_Valued_Property
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Property_Type_Designator : Node_Id
   --    Property_Expression      : Node_Id
   --

   procedure W_Single_Valued_Property (N : Node_Id);

   --
   --  Multi_Valued_Property
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Property_Type_Designator : Node_Id
   --    Property_Expressions     : List_Id
   --

   procedure W_Multi_Valued_Property (N : Node_Id);

   --
   --  Constant_Property_Declaration
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Constant_Type            : Node_Id
   --    Unique_Unit_Identifier   : Node_Id
   --    Constant_Value           : Node_Id
   --

   procedure W_Constant_Property_Declaration (N : Node_Id);

   --
   --  Property_Value
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Value_Container          : Node_Id
   --    Single_Value             : Node_Id
   --    Multi_Value              : List_Id
   --    Expanded_Single_Value    : Node_Id
   --    Expanded_Multi_Value     : List_Id
   --

   procedure W_Property_Value (N : Node_Id);

   --
   --  Property_Name_Declaration
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Is_Access                : Boolean
   --    Is_Inherit               : Boolean
   --    Property_Name_Type       : Node_Id
   --    Default_Value            : Node_Id
   --    Applies_To               : Node_Id
   --

   procedure W_Property_Name_Declaration (N : Node_Id);

   --
   --  Property_List_Value
   --
   --    First_Node               : Node_Id
   --    Last_Node                : Node_Id
   --

   procedure W_Property_List_Value (N : List_Id);

   --
   --  In_Binding
   --
   --    Next_Node                : Node_Id
   --    Binding                  : List_Id
   --

   procedure W_In_Binding (N : Node_Id);

   --
   --  Property_Association
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Property_Name            : Node_Id
   --    Is_Additive_Association  : Boolean
   --    Is_Constant              : Boolean
   --    Is_Private               : Boolean
   --    Is_Access                : Boolean
   --    Property_Association_Type: Node_Id
   --    Property_Association_Valu: Node_Id
   --    Applies_To_Prop          : List_Id
   --    In_Binding               : Node_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_Property_Association (N : Node_Id);

   --
   --  Literal
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Value                    : Value_Id
   --

   procedure W_Literal (N : Node_Id);

   --
   --  Signed_AADLNumber
   --
   --    Next_Node                : Node_Id
   --    Number_Value             : Node_Id
   --    Unit_Identifier          : Node_Id
   --

   procedure W_Signed_AADLNumber (N : Node_Id);

   --
   --  Not_Boolean_Term
   --
   --    Next_Node                : Node_Id
   --    Boolean_Term             : Node_Id
   --

   procedure W_Not_Boolean_Term (N : Node_Id);

   --
   --  And_Boolean_Term
   --
   --    Next_Node                : Node_Id
   --    First_Term               : Node_Id
   --    Second_Term              : Node_Id
   --

   procedure W_And_Boolean_Term (N : Node_Id);

   --
   --  Or_Boolean_Term
   --
   --    Next_Node                : Node_Id
   --    First_Term               : Node_Id
   --    Second_Term              : Node_Id
   --

   procedure W_Or_Boolean_Term (N : Node_Id);

   --
   --  Parenthesis_Boolean_Term
   --
   --    Next_Node                : Node_Id
   --    Boolean_Term             : Node_Id
   --

   procedure W_Parenthesis_Boolean_Term (N : Node_Id);

   --
   --  Minus_Numeric_Term
   --
   --    Next_Node                : Node_Id
   --    Numeric_Term             : Node_Id
   --

   procedure W_Minus_Numeric_Term (N : Node_Id);

   --
   --  Property_Term
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Path                     : List_Id
   --    Namespace_Path           : List_Id
   --    Namespace_Identifier     : Node_Id
   --    Full_Identifier          : Node_Id
   --    Entity                   : Node_Id
   --

   procedure W_Property_Term (N : Node_Id);

   --
   --  Number_Range_Term
   --
   --    Next_Node                : Node_Id
   --    Lower_Bound              : Node_Id
   --    Upper_Bound              : Node_Id
   --    Delta_Term               : Node_Id
   --

   procedure W_Number_Range_Term (N : Node_Id);

   --
   --  Component_Classifier_Term
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Path                     : List_Id
   --    Namespace_Path           : List_Id
   --    Namespace_Identifier     : Node_Id
   --    Full_Identifier          : Node_Id
   --    Entity                   : Node_Id
   --    Component_Cat            : Byte
   --

   procedure W_Component_Classifier_Term (N : Node_Id);

   --
   --  Reference_Term
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Path                     : List_Id
   --    Namespace_Path           : List_Id
   --    Namespace_Identifier     : Node_Id
   --    Full_Identifier          : Node_Id
   --    Entity                   : Node_Id
   --

   procedure W_Reference_Term (N : Node_Id);

   --
   --  Boolean_Type
   --
   --    Next_Node                : Node_Id
   --

   procedure W_Boolean_Type (N : Node_Id);

   --
   --  String_Type
   --
   --    Next_Node                : Node_Id
   --

   procedure W_String_Type (N : Node_Id);

   --
   --  Real_Type
   --
   --    Next_Node                : Node_Id
   --    Type_Range               : Node_Id
   --    Unit_Designator          : Node_Id
   --

   procedure W_Real_Type (N : Node_Id);

   --
   --  Integer_Type
   --
   --    Next_Node                : Node_Id
   --    Type_Range               : Node_Id
   --    Unit_Designator          : Node_Id
   --

   procedure W_Integer_Type (N : Node_Id);

   --
   --  Enumeration_Type
   --
   --    Next_Node                : Node_Id
   --    Identifiers              : List_Id
   --    Enumeration_Context      : Node_Id
   --

   procedure W_Enumeration_Type (N : Node_Id);

   --
   --  Number_Range
   --
   --    Next_Node                : Node_Id
   --    Lower_Bound              : Node_Id
   --    Upper_Bound              : Node_Id
   --

   procedure W_Number_Range (N : Node_Id);

   --
   --  Unit_Definition
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Unit_Identifier          : Node_Id
   --    Numeric_Literal          : Node_Id
   --

   procedure W_Unit_Definition (N : Node_Id);

   --
   --  Units_Type
   --
   --    Next_Node                : Node_Id
   --    Base_Identifier          : Node_Id
   --    Unit_Definitions         : List_Id
   --    Units_Context            : Node_Id
   --

   procedure W_Units_Type (N : Node_Id);

   --
   --  Range_Type
   --
   --    Next_Node                : Node_Id
   --    Number_Type              : Node_Id
   --

   procedure W_Range_Type (N : Node_Id);

   --
   --  Classifier_Type
   --
   --    First_Node               : Node_Id
   --    Last_Node                : Node_Id
   --

   procedure W_Classifier_Type (N : List_Id);

   --
   --  Referable_Element_Category
   --
   --    Next_Node                : Node_Id
   --    Component_Cat            : Byte
   --    Category                 : Byte
   --

   procedure W_Referable_Element_Category (N : Node_Id);

   --
   --  Reference_Type
   --
   --    First_Node               : Node_Id
   --    Last_Node                : Node_Id
   --

   procedure W_Reference_Type (N : List_Id);

   --
   --  Unique_Property_Type_Identifier
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Path                     : List_Id
   --    Namespace_Path           : List_Id
   --    Namespace_Identifier     : Node_Id
   --    Full_Identifier          : Node_Id
   --    Entity                   : Node_Id
   --

   procedure W_Unique_Property_Type_Identifier (N : Node_Id);

   --
   --  Property_Owner_Category
   --
   --    Next_Node                : Node_Id
   --    Category                 : Byte
   --    Component_Cat            : Byte
   --    Classifier_Ref           : Node_Id
   --

   procedure W_Property_Owner_Category (N : Node_Id);

   --
   --  Applies_To
   --
   --    Next_Node                : Node_Id
   --    Is_All                   : Boolean
   --    Owner_Categories         : List_Id
   --

   procedure W_Applies_To (N : Node_Id);

   --
   --  Unique_Property_Const_Identifier
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Path                     : List_Id
   --    Namespace_Path           : List_Id
   --    Namespace_Identifier     : Node_Id
   --    Full_Identifier          : Node_Id
   --    Entity                   : Node_Id
   --

   procedure W_Unique_Property_Const_Identifier (N : Node_Id);

   --
   --  Annex_Content
   --
   --    Next_Node                : Node_Id
   --    Raw_Text                 : Name_Id
   --

   procedure W_Annex_Content (N : Node_Id);

   --
   --  Annex_Subclause
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Container_Component      : Node_Id
   --    Annex_Content            : Node_Id
   --

   procedure W_Annex_Subclause (N : Node_Id);

   --
   --  Annex_Library
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Is_Private               : Boolean
   --    Annex_Content            : Node_Id
   --    Container_Package        : Node_Id
   --

   procedure W_Annex_Library (N : Node_Id);

   --
   --  Architecture_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Root_System              : Node_Id
   --    Virtual_Connections      : List_Id
   --    Namespaces               : List_Id
   --    Unnamed_Namespace        : Node_Id
   --

   procedure W_Architecture_Instance (N : Node_Id);

   --
   --  Entity_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --

   procedure W_Entity_Instance (N : Node_Id);

   --
   --  Entity_Reference_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Path                     : List_Id
   --

   procedure W_Entity_Reference_Instance (N : Node_Id);

   --
   --  Declaration_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --

   procedure W_Declaration_Instance (N : Node_Id);

   --
   --  Component_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Is_Private               : Boolean
   --    Features                 : List_Id
   --    Subcomponents            : List_Id
   --    Modes                    : List_Id
   --    Mode_transitions         : List_Id
   --    Connections              : List_Id
   --    Calls                    : List_Id
   --    Flows                    : List_Id
   --    Annexes                  : List_Id
   --    Parent_Subcomponent      : Node_Id
   --    Namespace                : Node_Id
   --    First_Homonym_In_Namespac: Node_Id
   --

   procedure W_Component_Instance (N : Node_Id);

   --
   --  Subcomponent_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Parent_Component         : Node_Id
   --    Corresponding_Instance   : Node_Id
   --    Destinations             : List_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_Subcomponent_Instance (N : Node_Id);

   --
   --  Namespace_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Declarations             : List_Id
   --

   procedure W_Namespace_Instance (N : Node_Id);

   --
   --  Feature_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Parent_Component         : Node_Id
   --    Sources                  : List_Id
   --    Destinations             : List_Id
   --

   procedure W_Feature_Instance (N : Node_Id);

   --
   --  Port_Spec_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Parent_Component         : Node_Id
   --    Sources                  : List_Id
   --    Destinations             : List_Id
   --    Is_In                    : Boolean
   --    Is_Out                   : Boolean
   --    Is_Event                 : Boolean
   --    Is_Data                  : Boolean
   --    Corresponding_Instance   : Node_Id
   --

   procedure W_Port_Spec_Instance (N : Node_Id);

   --
   --  Port_Group_Spec_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Parent_Component         : Node_Id
   --    Sources                  : List_Id
   --    Destinations             : List_Id
   --    Features                 : List_Id
   --

   procedure W_Port_Group_Spec_Instance (N : Node_Id);

   --
   --  Subprogram_Spec_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Parent_Component         : Node_Id
   --    Sources                  : List_Id
   --    Destinations             : List_Id
   --    Is_Server                : Boolean
   --    Corresponding_Instance   : Node_Id
   --

   procedure W_Subprogram_Spec_Instance (N : Node_Id);

   --
   --  Parameter_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Parent_Component         : Node_Id
   --    Sources                  : List_Id
   --    Destinations             : List_Id
   --    Is_In                    : Boolean
   --    Is_Out                   : Boolean
   --    Corresponding_Instance   : Node_Id
   --

   procedure W_Parameter_Instance (N : Node_Id);

   --
   --  Subcomponent_Access_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Parent_Component         : Node_Id
   --    Sources                  : List_Id
   --    Destinations             : List_Id
   --    Is_Provided              : Boolean
   --    Is_Data                  : Boolean
   --    Corresponding_Instance   : Node_Id
   --

   procedure W_Subcomponent_Access_Instance (N : Node_Id);

   --
   --  Call_Sequence_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Parent_Component         : Node_Id
   --    Subprogram_Calls         : List_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_Call_Sequence_Instance (N : Node_Id);

   --
   --  Call_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Parent_Sequence          : Node_Id
   --    Corresponding_Instance   : Node_Id
   --    Path                     : List_Id
   --

   procedure W_Call_Instance (N : Node_Id);

   --
   --  Mode_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Parent_Component         : Node_Id
   --    Is_Initial               : Boolean
   --

   procedure W_Mode_Instance (N : Node_Id);

   --
   --  Mode_Transition_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Parent_Component         : Node_Id
   --    Source_Modes             : List_Id
   --    Unique_Ports             : List_Id
   --    Destination_Mode         : Node_Id
   --

   procedure W_Mode_Transition_Instance (N : Node_Id);

   --
   --  Connection_Instance
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Source                   : Node_Id
   --    Destination              : Node_Id
   --    Associated_Type          : Node_Id
   --    Parent_Component         : Node_Id
   --    In_Modes                 : Node_Id
   --

   procedure W_Connection_Instance (N : Node_Id);

   --
   --  Virtual_Connection
   --
   --    Next_Node                : Node_Id
   --    Annotations              : List_Id
   --    Next_Entity              : Node_Id
   --    Identifier               : Node_Id
   --    Corresponding_Declaration: Node_Id
   --    Annotation               : Node_Id
   --    Properties               : List_Id
   --    Source                   : Node_Id
   --    Destination              : Node_Id
   --    Associated_Type          : Node_Id
   --    Parent_Component         : Node_Id
   --    In_Modes                 : Node_Id
   --    Connection_Instances     : List_Id
   --

   procedure W_Virtual_Connection (N : Node_Id);

   function Kind (N : Node_Id) return Node_Kind;
   procedure Set_Kind (N : Node_Id; V : Node_Kind);

   function Loc (N : Node_Id) return Location;
   procedure Set_Loc (N : Node_Id; V : Location);

   function Next_Node (N : Node_Id) return Node_Id;
   procedure Set_Next_Node (N : Node_Id; V : Node_Id);

   function First_Node (N : List_Id) return Node_Id;
   procedure Set_First_Node (N : List_Id; V : Node_Id);

   function Last_Node (N : List_Id) return Node_Id;
   procedure Set_Last_Node (N : List_Id; V : Node_Id);

   function Annotations (N : Node_Id) return List_Id;
   procedure Set_Annotations (N : Node_Id; V : List_Id);

   function Annotation_Node (N : Node_Id) return Node_Id;
   procedure Set_Annotation_Node (N : Node_Id; V : Node_Id);

   function Annotation_Name (N : Node_Id) return Name_Id;
   procedure Set_Annotation_Name (N : Node_Id; V : Name_Id);

   function Annotation_Info (N : Node_Id) return Node_Id;
   procedure Set_Annotation_Info (N : Node_Id; V : Node_Id);

   function Item (N : Node_Id) return Node_Id;
   procedure Set_Item (N : Node_Id; V : Node_Id);

   function Extra_Item (N : Node_Id) return Node_Id;
   procedure Set_Extra_Item (N : Node_Id; V : Node_Id);

   function Scoped_Identifiers (N : Node_Id) return Node_Id;
   procedure Set_Scoped_Identifiers (N : Node_Id; V : Node_Id);

   function Corresponding_Entity (N : Node_Id) return Node_Id;
   procedure Set_Corresponding_Entity (N : Node_Id; V : Node_Id);

   function Name (N : Node_Id) return Name_Id;
   procedure Set_Name (N : Node_Id; V : Name_Id);

   function Display_Name (N : Node_Id) return Name_Id;
   procedure Set_Display_Name (N : Node_Id; V : Name_Id);

   function Scope_Entity (N : Node_Id) return Node_Id;
   procedure Set_Scope_Entity (N : Node_Id; V : Node_Id);

   function Potential_Scope (N : Node_Id) return Node_Id;
   procedure Set_Potential_Scope (N : Node_Id; V : Node_Id);

   function Homonym (N : Node_Id) return Node_Id;
   procedure Set_Homonym (N : Node_Id; V : Node_Id);

   function Visible (N : Node_Id) return Boolean;
   procedure Set_Visible (N : Node_Id; V : Boolean);

   function Backend_Node (N : Node_Id) return Node_Id;
   procedure Set_Backend_Node (N : Node_Id; V : Node_Id);

   function Next_Entity (N : Node_Id) return Node_Id;
   procedure Set_Next_Entity (N : Node_Id; V : Node_Id);

   function Identifier (N : Node_Id) return Node_Id;
   procedure Set_Identifier (N : Node_Id; V : Node_Id);

   function Entity_Scope (N : Node_Id) return Node_Id;
   procedure Set_Entity_Scope (N : Node_Id; V : Node_Id);

   function Property_Scope (N : Node_Id) return Node_Id;
   procedure Set_Property_Scope (N : Node_Id; V : Node_Id);

   function Is_Private (N : Node_Id) return Boolean;
   procedure Set_Is_Private (N : Node_Id; V : Boolean);

   function First_Visited_Node (N : Node_Id) return Node_Id;
   procedure Set_First_Visited_Node (N : Node_Id; V : Node_Id);

   function Namespace (N : Node_Id) return Node_Id;
   procedure Set_Namespace (N : Node_Id; V : Node_Id);

   function Default_Instance (N : Node_Id) return Node_Id;
   procedure Set_Default_Instance (N : Node_Id; V : Node_Id);

   function Reference (N : Node_Id) return Node_Id;
   procedure Set_Reference (N : Node_Id; V : Node_Id);

   function Parent_Entity (N : Node_Id) return Node_Id;
   procedure Set_Parent_Entity (N : Node_Id; V : Node_Id);

   function Depth (N : Node_Id) return Int;
   procedure Set_Depth (N : Node_Id; V : Int);

   function Next_Scoped_Name (N : Node_Id) return Node_Id;
   procedure Set_Next_Scoped_Name (N : Node_Id; V : Node_Id);

   function Path (N : Node_Id) return List_Id;
   procedure Set_Path (N : Node_Id; V : List_Id);

   function Namespace_Path (N : Node_Id) return List_Id;
   procedure Set_Namespace_Path (N : Node_Id; V : List_Id);

   function Namespace_Identifier (N : Node_Id) return Node_Id;
   procedure Set_Namespace_Identifier (N : Node_Id; V : Node_Id);

   function Full_Identifier (N : Node_Id) return Node_Id;
   procedure Set_Full_Identifier (N : Node_Id; V : Node_Id);

   function Entity (N : Node_Id) return Node_Id;
   procedure Set_Entity (N : Node_Id; V : Node_Id);

   function First_Reference (N : Node_Id) return Node_Id;
   procedure Set_First_Reference (N : Node_Id; V : Node_Id);

   function Second_Reference (N : Node_Id) return Node_Id;
   procedure Set_Second_Reference (N : Node_Id; V : Node_Id);

   function Declarations (N : Node_Id) return List_Id;
   procedure Set_Declarations (N : Node_Id; V : List_Id);

   function Has_Private_Part (N : Node_Id) return Boolean;
   procedure Set_Has_Private_Part (N : Node_Id; V : Boolean);

   function Has_Public_Part (N : Node_Id) return Boolean;
   procedure Set_Has_Public_Part (N : Node_Id; V : Boolean);

   function Properties (N : Node_Id) return List_Id;
   procedure Set_Properties (N : Node_Id; V : List_Id);

   function Category (N : Node_Id) return Byte;
   procedure Set_Category (N : Node_Id; V : Byte);

   function Features (N : Node_Id) return List_Id;
   procedure Set_Features (N : Node_Id; V : List_Id);

   function Flows (N : Node_Id) return List_Id;
   procedure Set_Flows (N : Node_Id; V : List_Id);

   function Annexes (N : Node_Id) return List_Id;
   procedure Set_Annexes (N : Node_Id; V : List_Id);

   function Parent (N : Node_Id) return Node_Id;
   procedure Set_Parent (N : Node_Id; V : Node_Id);

   function Instances (N : Node_Id) return List_Id;
   procedure Set_Instances (N : Node_Id; V : List_Id);

   function Component_Type_Identifier (N : Node_Id) return Node_Id;
   procedure Set_Component_Type_Identifier (N : Node_Id; V : Node_Id);

   function Refines_Type (N : Node_Id) return List_Id;
   procedure Set_Refines_Type (N : Node_Id; V : List_Id);

   function Subcomponents (N : Node_Id) return List_Id;
   procedure Set_Subcomponents (N : Node_Id; V : List_Id);

   function Calls (N : Node_Id) return List_Id;
   procedure Set_Calls (N : Node_Id; V : List_Id);

   function Connections (N : Node_Id) return List_Id;
   procedure Set_Connections (N : Node_Id; V : List_Id);

   function Modes (N : Node_Id) return List_Id;
   procedure Set_Modes (N : Node_Id; V : List_Id);

   function Container_Component (N : Node_Id) return Node_Id;
   procedure Set_Container_Component (N : Node_Id; V : Node_Id);

   function Entity_Ref (N : Node_Id) return Node_Id;
   procedure Set_Entity_Ref (N : Node_Id; V : Node_Id);

   function Is_Implicit_Inverse (N : Node_Id) return Boolean;
   procedure Set_Is_Implicit_Inverse (N : Node_Id; V : Boolean);

   function Inversed_Entity (N : Node_Id) return Node_Id;
   procedure Set_Inversed_Entity (N : Node_Id; V : Node_Id);

   function Is_Refinement (N : Node_Id) return Boolean;
   procedure Set_Is_Refinement (N : Node_Id; V : Boolean);

   function Is_In (N : Node_Id) return Boolean;
   procedure Set_Is_In (N : Node_Id; V : Boolean);

   function Is_Out (N : Node_Id) return Boolean;
   procedure Set_Is_Out (N : Node_Id; V : Boolean);

   function Is_Event (N : Node_Id) return Boolean;
   procedure Set_Is_Event (N : Node_Id; V : Boolean);

   function Is_Data (N : Node_Id) return Boolean;
   procedure Set_Is_Data (N : Node_Id; V : Boolean);

   function Is_Server (N : Node_Id) return Boolean;
   procedure Set_Is_Server (N : Node_Id; V : Boolean);

   function Is_Provided (N : Node_Id) return Boolean;
   procedure Set_Is_Provided (N : Node_Id; V : Boolean);

   function Subcomponent_Category (N : Node_Id) return Byte;
   procedure Set_Subcomponent_Category (N : Node_Id; V : Byte);

   function Source_Flow (N : Node_Id) return Node_Id;
   procedure Set_Source_Flow (N : Node_Id; V : Node_Id);

   function Sink_Flow (N : Node_Id) return Node_Id;
   procedure Set_Sink_Flow (N : Node_Id; V : Node_Id);

   function Is_Initial (N : Node_Id) return Boolean;
   procedure Set_Is_Initial (N : Node_Id; V : Boolean);

   function Source_Modes (N : Node_Id) return List_Id;
   procedure Set_Source_Modes (N : Node_Id; V : List_Id);

   function Unique_Ports (N : Node_Id) return List_Id;
   procedure Set_Unique_Ports (N : Node_Id; V : List_Id);

   function Destination_Mode (N : Node_Id) return Node_Id;
   procedure Set_Destination_Mode (N : Node_Id; V : Node_Id);

   function In_Modes (N : Node_Id) return Node_Id;
   procedure Set_In_Modes (N : Node_Id; V : Node_Id);

   function Parent_Sequence (N : Node_Id) return Node_Id;
   procedure Set_Parent_Sequence (N : Node_Id; V : Node_Id);

   function Subprogram_Calls (N : Node_Id) return List_Id;
   procedure Set_Subprogram_Calls (N : Node_Id; V : List_Id);

   function Inverse_Of (N : Node_Id) return Node_Id;
   procedure Set_Inverse_Of (N : Node_Id; V : Node_Id);

   function Source (N : Node_Id) return Node_Id;
   procedure Set_Source (N : Node_Id; V : Node_Id);

   function Destination (N : Node_Id) return Node_Id;
   procedure Set_Destination (N : Node_Id; V : Node_Id);

   function Property_Set_Context (N : Node_Id) return Node_Id;
   procedure Set_Property_Set_Context (N : Node_Id; V : Node_Id);

   function Is_List (N : Node_Id) return Boolean;
   procedure Set_Is_List (N : Node_Id; V : Boolean);

   function Property_Type_Designator (N : Node_Id) return Node_Id;
   procedure Set_Property_Type_Designator (N : Node_Id; V : Node_Id);

   function Expanded_Type_Designator (N : Node_Id) return Node_Id;
   procedure Set_Expanded_Type_Designator (N : Node_Id; V : Node_Id);

   function Property_Expression (N : Node_Id) return Node_Id;
   procedure Set_Property_Expression (N : Node_Id; V : Node_Id);

   function Property_Expressions (N : Node_Id) return List_Id;
   procedure Set_Property_Expressions (N : Node_Id; V : List_Id);

   function Constant_Type (N : Node_Id) return Node_Id;
   procedure Set_Constant_Type (N : Node_Id; V : Node_Id);

   function Unique_Unit_Identifier (N : Node_Id) return Node_Id;
   procedure Set_Unique_Unit_Identifier (N : Node_Id; V : Node_Id);

   function Constant_Value (N : Node_Id) return Node_Id;
   procedure Set_Constant_Value (N : Node_Id; V : Node_Id);

   function Value_Container (N : Node_Id) return Node_Id;
   procedure Set_Value_Container (N : Node_Id; V : Node_Id);

   function Single_Value (N : Node_Id) return Node_Id;
   procedure Set_Single_Value (N : Node_Id; V : Node_Id);

   function Multi_Value (N : Node_Id) return List_Id;
   procedure Set_Multi_Value (N : Node_Id; V : List_Id);

   function Expanded_Single_Value (N : Node_Id) return Node_Id;
   procedure Set_Expanded_Single_Value (N : Node_Id; V : Node_Id);

   function Expanded_Multi_Value (N : Node_Id) return List_Id;
   procedure Set_Expanded_Multi_Value (N : Node_Id; V : List_Id);

   function Is_Access (N : Node_Id) return Boolean;
   procedure Set_Is_Access (N : Node_Id; V : Boolean);

   function Is_Inherit (N : Node_Id) return Boolean;
   procedure Set_Is_Inherit (N : Node_Id; V : Boolean);

   function Property_Name_Type (N : Node_Id) return Node_Id;
   procedure Set_Property_Name_Type (N : Node_Id; V : Node_Id);

   function Default_Value (N : Node_Id) return Node_Id;
   procedure Set_Default_Value (N : Node_Id; V : Node_Id);

   function Applies_To (N : Node_Id) return Node_Id;
   procedure Set_Applies_To (N : Node_Id; V : Node_Id);

   function Binding (N : Node_Id) return List_Id;
   procedure Set_Binding (N : Node_Id; V : List_Id);

   function Property_Name (N : Node_Id) return Node_Id;
   procedure Set_Property_Name (N : Node_Id; V : Node_Id);

   function Is_Additive_Association (N : Node_Id) return Boolean;
   procedure Set_Is_Additive_Association (N : Node_Id; V : Boolean);

   function Is_Constant (N : Node_Id) return Boolean;
   procedure Set_Is_Constant (N : Node_Id; V : Boolean);

   function Property_Association_Type (N : Node_Id) return Node_Id;
   procedure Set_Property_Association_Type (N : Node_Id; V : Node_Id);

   function Property_Association_Value (N : Node_Id) return Node_Id;
   procedure Set_Property_Association_Value (N : Node_Id; V : Node_Id);

   function Applies_To_Prop (N : Node_Id) return List_Id;
   procedure Set_Applies_To_Prop (N : Node_Id; V : List_Id);

   function In_Binding (N : Node_Id) return Node_Id;
   procedure Set_In_Binding (N : Node_Id; V : Node_Id);

   function Value (N : Node_Id) return Value_Id;
   procedure Set_Value (N : Node_Id; V : Value_Id);

   function Number_Value (N : Node_Id) return Node_Id;
   procedure Set_Number_Value (N : Node_Id; V : Node_Id);

   function Unit_Identifier (N : Node_Id) return Node_Id;
   procedure Set_Unit_Identifier (N : Node_Id; V : Node_Id);

   function Boolean_Term (N : Node_Id) return Node_Id;
   procedure Set_Boolean_Term (N : Node_Id; V : Node_Id);

   function First_Term (N : Node_Id) return Node_Id;
   procedure Set_First_Term (N : Node_Id; V : Node_Id);

   function Second_Term (N : Node_Id) return Node_Id;
   procedure Set_Second_Term (N : Node_Id; V : Node_Id);

   function Numeric_Term (N : Node_Id) return Node_Id;
   procedure Set_Numeric_Term (N : Node_Id; V : Node_Id);

   function Lower_Bound (N : Node_Id) return Node_Id;
   procedure Set_Lower_Bound (N : Node_Id; V : Node_Id);

   function Upper_Bound (N : Node_Id) return Node_Id;
   procedure Set_Upper_Bound (N : Node_Id; V : Node_Id);

   function Delta_Term (N : Node_Id) return Node_Id;
   procedure Set_Delta_Term (N : Node_Id; V : Node_Id);

   function Component_Cat (N : Node_Id) return Byte;
   procedure Set_Component_Cat (N : Node_Id; V : Byte);

   function Type_Range (N : Node_Id) return Node_Id;
   procedure Set_Type_Range (N : Node_Id; V : Node_Id);

   function Unit_Designator (N : Node_Id) return Node_Id;
   procedure Set_Unit_Designator (N : Node_Id; V : Node_Id);

   function Identifiers (N : Node_Id) return List_Id;
   procedure Set_Identifiers (N : Node_Id; V : List_Id);

   function Enumeration_Context (N : Node_Id) return Node_Id;
   procedure Set_Enumeration_Context (N : Node_Id; V : Node_Id);

   function Numeric_Literal (N : Node_Id) return Node_Id;
   procedure Set_Numeric_Literal (N : Node_Id; V : Node_Id);

   function Base_Identifier (N : Node_Id) return Node_Id;
   procedure Set_Base_Identifier (N : Node_Id; V : Node_Id);

   function Unit_Definitions (N : Node_Id) return List_Id;
   procedure Set_Unit_Definitions (N : Node_Id; V : List_Id);

   function Units_Context (N : Node_Id) return Node_Id;
   procedure Set_Units_Context (N : Node_Id; V : Node_Id);

   function Number_Type (N : Node_Id) return Node_Id;
   procedure Set_Number_Type (N : Node_Id; V : Node_Id);

   function Classifier_Ref (N : Node_Id) return Node_Id;
   procedure Set_Classifier_Ref (N : Node_Id; V : Node_Id);

   function Is_All (N : Node_Id) return Boolean;
   procedure Set_Is_All (N : Node_Id; V : Boolean);

   function Owner_Categories (N : Node_Id) return List_Id;
   procedure Set_Owner_Categories (N : Node_Id; V : List_Id);

   function Raw_Text (N : Node_Id) return Name_Id;
   procedure Set_Raw_Text (N : Node_Id; V : Name_Id);

   function Annex_Content (N : Node_Id) return Node_Id;
   procedure Set_Annex_Content (N : Node_Id; V : Node_Id);

   function Container_Package (N : Node_Id) return Node_Id;
   procedure Set_Container_Package (N : Node_Id; V : Node_Id);

   function Root_System (N : Node_Id) return Node_Id;
   procedure Set_Root_System (N : Node_Id; V : Node_Id);

   function Virtual_Connections (N : Node_Id) return List_Id;
   procedure Set_Virtual_Connections (N : Node_Id; V : List_Id);

   function Namespaces (N : Node_Id) return List_Id;
   procedure Set_Namespaces (N : Node_Id; V : List_Id);

   function Unnamed_Namespace (N : Node_Id) return Node_Id;
   procedure Set_Unnamed_Namespace (N : Node_Id; V : Node_Id);

   function Corresponding_Declaration (N : Node_Id) return Node_Id;
   procedure Set_Corresponding_Declaration (N : Node_Id; V : Node_Id);

   function Annotation (N : Node_Id) return Node_Id;
   procedure Set_Annotation (N : Node_Id; V : Node_Id);

   function Mode_transitions (N : Node_Id) return List_Id;
   procedure Set_Mode_transitions (N : Node_Id; V : List_Id);

   function Parent_Subcomponent (N : Node_Id) return Node_Id;
   procedure Set_Parent_Subcomponent (N : Node_Id; V : Node_Id);

   function First_Homonym_In_Namespace (N : Node_Id) return Node_Id;
   procedure Set_First_Homonym_In_Namespace (N : Node_Id; V : Node_Id);

   function Parent_Component (N : Node_Id) return Node_Id;
   procedure Set_Parent_Component (N : Node_Id; V : Node_Id);

   function Corresponding_Instance (N : Node_Id) return Node_Id;
   procedure Set_Corresponding_Instance (N : Node_Id; V : Node_Id);

   function Destinations (N : Node_Id) return List_Id;
   procedure Set_Destinations (N : Node_Id; V : List_Id);

   function Sources (N : Node_Id) return List_Id;
   procedure Set_Sources (N : Node_Id; V : List_Id);

   function Associated_Type (N : Node_Id) return Node_Id;
   procedure Set_Associated_Type (N : Node_Id; V : Node_Id);

   function Connection_Instances (N : Node_Id) return List_Id;
   procedure Set_Connection_Instances (N : Node_Id; V : List_Id);

   procedure W_Node (N : Node_Id);

   type Boolean_Array is array (1 .. 6) of Boolean;
   type Byte_Array is array (1 .. 4) of Byte;
   type Int_Array is array (1 .. 22) of Int;

   type Node_Entry is record
      Kind : Node_Kind;
      B : Boolean_Array;
      O : Byte_Array;
      L : Int_Array;
      Loc : Location;
   end record;

   Default_Node : constant Node_Entry :=
     (Node_Kind'First,
      (others => False),
      (others => 0),
      (others => 0),
      No_Location);

   package Entries is new GNAT.Table
     (Node_Entry, Node_Id, No_Node + 1, 1000, 100);

end Ocarina.Nodes;
