------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--   O C A R I N A . D I A . P A R S E R . C O R E . A T T R I B U T E S    --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package implements the parsing of object's attributes

with DOM.Core;

package Ocarina.Dia.Parser.Core.Attributes is

   Missing_Dia_Attribute : exception;
   --  Raised when the required attribute does not appear in the
   --  node's children

   function Get_Attribute_Node
     (NL : DOM.Core.Node_List; Name : String)
     return DOM.Core.Node;
   --  Parses the dia:attribute node list of an object, and looks for
   --  a particular one

   Illformed_Dia_Attribute : exception;
   --  Raised by the functions below if the node is not as expected

   function Get_Name_Attribute (E : DOM.Core.Node) return Unbounded_String;
   function Get_String_Attribute (E : DOM.Core.Node) return Unbounded_String;
   function Get_Val_Attribute (E : DOM.Core.Node) return Unbounded_String;
   --  Set of functions to parse attribute nodes with a specific shape :
   --  * name attributes (object's visible text)
   --  * string attributes (all strings, e.g. declarations)
   --  * values (other types of data stored in strings, e.g. positions)

end Ocarina.Dia.Parser.Core.Attributes;
