------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--      O C A R I N A . D I A . P A R S E R . C O R E . D I A G R A M       --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2005-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with DOM.Core.Nodes;
with Ocarina.Dia.Parser.Core.Layer;

package body Ocarina.Dia.Parser.Core.Diagram is

   --  Process a dia XML file and returns the list of the nodes
   function Process_Diagram (XMLN : DOM.Core.Node) return Node_List is
      use DOM.Core;
      NL : Node_List := Null_List;
   begin
      if XMLN.Node_Type = Element_Node
        and then DOM.Core.Nodes.Node_Name (XMLN) = "dia:diagram"
      then

         declare
            use Ocarina.Dia.Parser.Core.Layer;
            Child : DOM.Core.Node :=
              DOM.Core.Nodes.First_Child (XMLN);
         begin
            --  TODO : Do something with the first child that is, the
            --  diagram data (at least a check)

            Child := DOM.Core.Nodes.Next_Sibling (Child);
            while Child /= null loop
               Process_Layer (Child, NL);
               Child := DOM.Core.Nodes.Next_Sibling (Child);
            end loop;
         end;
      end if;
      return NL;
   end Process_Diagram;

end Ocarina.Dia.Parser.Core.Diagram;
