------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--        O C A R I N A . D I A . P A R S E R . C O R E . L A Y E R         --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2005-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with DOM.Core.Nodes;
with Ocarina.Dia.Parser.Core.Nodes;

package body Ocarina.Dia.Parser.Core.Layer is

   --  Goes through all the XML element, creates the nodes and returns
   --  a list of all nodes
   procedure Process_Layer (N : DOM.Core.Node; NL : in out Node_List) is
      use DOM.Core;
      use Ocarina.Dia.Parser.Core.Nodes;

      Child : DOM.Core.Node := DOM.Core.Nodes.First_Child (N);
      E : Node;
      Counter : Natural := 0;

   begin
      if N.Node_Type = Element_Node
        and then DOM.Core.Nodes.Node_Name (N) = "dia:layer"
      then
         --  TODO : ignore if its not a visible layer ?

         while Child /= null loop
            E := Get_Node (Child, Counter);

            if E /= null then
               Append (NL, E);
               Counter := Counter + 1;
            end if;

            Child := DOM.Core.Nodes.Next_Sibling (Child);
         end loop;
      end if;
   end Process_Layer;

end Ocarina.Dia.Parser.Core.Layer;
