------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--        O C A R I N A . D I A . P A R S E R . C O R E . P O R T S         --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package implements the parsing of object's ports and
--  connection points.

with DOM.Core;

package Ocarina.Dia.Parser.Core.Ports is

   procedure Print_Port (P : Port);
   --  Prints a single port (for debugging)

   procedure Print_Ports (PL : Port_List);
   --  Prints a list of ports (for debugging)

   function Match_Port (S : Unbounded_String) return Port_Type;
   --  Translates the port ID in the Dia element to a Port_Type

   Unknown_Port : exception;
   --  Raised if an unknown kind of port is discovered

   function Get_Port (N : DOM.Core.Node) return Port;
   --  Retrieves a port from a Dia element

   function Get_Ports (Children : DOM.Core.Node_List) return Port_List;
   --  Retrieves a list of ports from an <aadlbox_Ports> element

   function Get_Port
      (N : Ocarina.Dia.Parser.Core.Node;
       I : Integer)
      return Port;
   --  Retrieves a list of port objects from an aadlbox_Ports attribute

   function Has_Ports
      (N : Ocarina.Dia.Parser.Core.Node)
      return Boolean;

   function Get_Port_Declaration (P : Port)
      return String;

end Ocarina.Dia.Parser.Core.Ports;
