------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--    O C A R I N A . D I A . P A R S E R . T R A N S L A T E . M I S C     --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2005-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Ada.Text_IO; use Ada.Text_IO;
with Ada.Strings.Fixed;

package body Ocarina.Dia.Parser.Translate.Misc is

   -----------------
   --  Type_Name  --
   -----------------

   function Stripped_Name
      (S : String)
      return String
   is
      use Ada.Strings.Fixed;
   begin
      --  todo If this function is to be used
      --  check the difference betwenn 1.. and 2.. !
      return S (S'First + 1 .. Index (S, " ") - 1);
   end Stripped_Name;

   -----------------
   --  Node_Name  --
   -----------------

   function Node_Name
      (S : String)
      return String
   is
      use Ada.Strings.Fixed;
   begin
      if S (S'First) = '#'
        and then S (S'Last) = '#'
        and then S'Length /= 2
      then
         return S (S'First + 1 .. S'Last - 1);
      else
         Put_Line ("Warning : Node Name isn't surrounded by #. "
                   & "String returned unchanged");
         return S;
      end if;
   end Node_Name;

end Ocarina.Dia.Parser.Translate.Misc;
