------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--            O C A R I N A . D I A . P R I N T E R . A R R O W             --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with DOM.Core;

package Ocarina.Dia.Printer.Arrow is

   --  this function adds a connection to an arrow Parent_Node must be
   --  <dia:connections></dia:connections>
   procedure Add_Connection
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Handle : String;
      To : String;
      Connection : String);

   --  this function adds an arrow to a layer.
   procedure Add_Arrow
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Type_Arrow : String;
      Id_Arrow : Integer;
      Id_Root : String;
      FirstHandle : Integer;
      Id_Target : String;
      LastHandle : Integer);

   --  this function adds a line to a layer.
   procedure Add_Line
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Id_Arrow : Integer;
      Id_Root : String;
      FirstHandle : Integer;
      Id_Target : String;
      LastHandle : Integer;
      Parent : Integer);

   --  this function should add an ULM arrow between the Element Root
   --  and Target
   procedure Add_Link_Extension
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Root : DOM.Core.Node;
      Target : Node_Id;
      Next_Id : Integer);

   --  this procedure adds an UML arrow
   procedure Add_Link_Implementation
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Root : DOM.Core.Node;
      Target : Node_Id;
      Next_Id : Integer);

   --  this function adds an AADL connection in the diagram
   procedure Add_AADLConnection
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Root : Node_Id;
      Target : Node_Id;
      Next_Id : Integer;
      Parent : Integer;
      Name : String);

   function Get_Id_Of_Port
     (Doc : DOM.Core.Document;
      Node : Node_Id;
      Name : String)
     return String;

   --  return the number of the connection
   function Get_Connection_Number
     (Doc : DOM.Core.Document;
      Node : Node_Id;
      I : String)
     return Integer;

end Ocarina.Dia.Printer.Arrow;
