------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--        O C A R I N A . D I A . P R I N T E R . A T T R I B U T E         --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package contains the top-level procedures to create the
--  attributes for the Dia file

with Ocarina.Dia.Printer.Misc;

package Ocarina.Dia.Printer.Attribute is

   --  Add_Attr* insert as a child of Parent_Node :
   --  <dia:attribute dia:name=arg_Name><dia:* val=last_Arg>
   --     </dia:*></dia:attribute>

   --  Add_Attr_String insert something like :
   --  <dia:attribute dia:name=arg_Name><dia:string>last_Arg>
   --      </dia:string></dia:attribute>

   procedure Add_Attr_Color
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Color : String);

   procedure Add_Attr_String
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String; str : String);

   procedure Add_Attr_Real
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Real : Float);

   procedure Add_Attr_Boolean
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Bool : Boolean);

   procedure Add_Attr_Int
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Int : Integer);

   procedure Add_Attr_Point
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Point : Ocarina.Dia.Printer.Misc.Point);

   procedure Add_Attr_Rectangle
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Rectangle : Ocarina.Dia.Printer.Misc.Rectangle);

   procedure Add_Attr_Enum
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Enum : String);

   procedure Add_Attr_Font
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Name : String;
      Family : String;
      Style : String;
      Name_Font : String);

   --  Add_* insert as  child of Parent_Node
   --  <dia:* val=last_Arg></dia:*>

   procedure Add_Point
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Point : Ocarina.Dia.Printer.Misc.Point);

   procedure Add_Enum
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Enum : String);

end Ocarina.Dia.Printer.Attribute;
