------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--      O C A R I N A . D I A . P R I N T E R . D I A G R A M D A T A       --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package contains the top-level procedures to create the
--  Diagram Data of the Dia file

package Ocarina.Dia.Printer.Diagramdata is

   procedure Add_Paper
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node);

   procedure Add_Grid
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node);

   procedure Add_Guides
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node);

   --  this function will create the Diagram Data of the DIA file,
   --  which contains informations such as grid, paper, size of the
   --  frame...
   procedure Create_Diagram_Data
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node);

end Ocarina.Dia.Printer.Diagramdata;
