------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                  O C A R I N A . D I A . P R I N T E R                   --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package contains the top-level procedures
--  to convert the abstract syntax tree into a XML/Dia file

with Types; use Types;
with DOM.Core; use DOM.Core;
with Ocarina.Printer;

package Ocarina.Dia.Printer is

   --  Initialization
   procedure Init;

   --  this function will create the header of the xml/dia DOM Tree
   procedure Create_Header
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node);

   --  this function will create the diagram element of the xml/dia
   --  DOM Tree
   procedure Create_Diagram
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Node : Node_Id);

   procedure Analyse_Node
     (Doc : DOM.Core.Document;
      Parent_Node : DOM.Core.Node;
      Node : Node_Id);
   --  This function will go recursively the internal Ocarina tree and
   --  write an Dia/Xml file

   procedure Print_Node
     (Node : Types.Node_Id;
      Options : Ocarina.Printer.Output_Options :=
        Ocarina.Printer.Default_Output_Options);

end Ocarina.Dia.Printer;
