------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--             O C A R I N A . D U M P E R . A A D L _ T R E E              --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Output;
with Ocarina.Debug;
with Ocarina.Expander;

package body Ocarina.Dumper.AADL_Tree is

   ----------
   -- Init --
   ----------

   procedure Init is
      use Ocarina.Printer;
   begin
      Register_Printer ("aadl_tree_p", Dump_AADL_Parsed_Tree'Access);
      Register_Printer ("aadl_tree_e", Dump_AADL_Expanded_Tree'Access);
   end Init;

   ---------------------------
   -- Dump_AADL_Parsed_Tree --
   ---------------------------

   procedure Dump_AADL_Parsed_Tree
     (Node : Node_Id;
      Options : Ocarina.Printer.Output_Options :=
        Ocarina.Printer.Default_Output_Options)
   is
      use Output;
      use Ocarina.Debug;
      use Ocarina.Printer;
   begin
      Set_Output (Create_Output_File (Options));
      W_Node_Id (Node);
      Set_Standard_Output;
   end Dump_AADL_Parsed_Tree;

   -----------------------------
   -- Dump_AADL_Expanded_Tree --
   -----------------------------

   procedure Dump_AADL_Expanded_Tree
     (Node : Node_Id;
      Options : Ocarina.Printer.Output_Options :=
        Ocarina.Printer.Default_Output_Options)
   is
      use Output;
      use Ocarina.Debug;
      use Ocarina.Printer;

      Instance_Root : Node_Id;
   begin
      Instance_Root := Ocarina.Expander.Expand_Model (Node);
      Set_Output (Create_Output_File (Options));
      W_Node_Id (Instance_Root);
      Set_Standard_Output;
   end Dump_AADL_Expanded_Tree;

end Ocarina.Dumper.AADL_Tree;
