------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                    G A I A . P N . G E N E R A T O R                     --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Types;
with Gaia.Mgmt;

package Gaia.Pn.Generator is

   procedure Generate
     (Distributed_Application_Root : Types.Node_Id;
      Options : Gaia.Mgmt.Gaia_Options;
      Success : out Boolean);
   --  The main generator of the PetriNet module for the
   --  PolyORB-based runtime.

   procedure Translate
     (Distributed_Application_Root : Types.Node_Id;
      Options : Gaia.Mgmt.Gaia_Options;
      Success : out Boolean);
   --  The main translator of the PetriNet module

   procedure Init;
   --  Initialize and register the PolyORB-based runtime generator to
   --  the general Gaia generator.

   procedure Reset;
   --  Resets the PN tree nodes

end Gaia.Pn.Generator;
