------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                              G A I A . P N                               --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2005-2006, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package generates a pn tree

with Types;
with Gaia.Mgmt;

package Gaia.Pn is

   function Process_Distributed_Application
     (DA : Types.Node_Id;
      Options : Gaia.Mgmt.Gaia_Options)
     return Types.Node_Id;
   --  Transform the gaia tree of the distributed application
   --  nodes into a petrinet (pn) tree.

   --  A structure to describe both node location & container extrema
   --  positions

   type Node_Location is record
      X : Natural;
      Y : Natural;
   end record;

   --  Naming policy
   Full_Naming_Policy : constant Boolean := True;

   --  FIXME : that variable only make sense when used without
   --  Full_Naming_Policy
   Current_Thread : Types.Node_Id;

end Gaia.Pn;
