------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                     O C A R I N A . P N . N O D E S                      --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                 Copyright (C) 2007, GET-Telecom Paris.                   --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

pragma Style_Checks ("NM32766");

--  This file has been generated automatically by `mknodes'. Do not
--  hand modify this file since your changes will be overridden.

with Ocarina.PN.Debug; use Ocarina.PN.Debug;

package body Ocarina.PN.Nodes is

   pragma Warnings (Off);
   use Entries;

   function Kind (N : Node_Id) return Node_Kind is
   begin
      return Table (Node_Id (N)).Kind;
   end Kind;

   procedure Set_Kind (N : Node_Id; V : Node_Kind) is
   begin
      Table (Node_Id (N)).Kind := V;
   end Set_Kind;

   function Loc (N : Node_Id) return Location is
   begin
      return Table (Node_Id (N)).Loc;
   end Loc;

   procedure Set_Loc (N : Node_Id; V : Location) is
   begin
      Table (Node_Id (N)).Loc := V;
   end Set_Loc;

   function Next_Node (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Node_Id
        or else Table (Node_Id (N)).Kind = K_Indirection
        or else Table (Node_Id (N)).Kind = K_Identifier
        or else Table (Node_Id (N)).Kind = K_Pn_Definition
        or else Table (Node_Id (N)).Kind = K_Scoped_Name
        or else Table (Node_Id (N)).Kind = K_Pn_Scope_Definition
        or else Table (Node_Id (N)).Kind = K_Position
        or else Table (Node_Id (N)).Kind = K_Color_Variable
        or else Table (Node_Id (N)).Kind = K_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Enumeration_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Domain_Declaration
        or else Table (Node_Id (N)).Kind = K_Variables_Declaration
        or else Table (Node_Id (N)).Kind = K_Symbolic_Value
        or else Table (Node_Id (N)).Kind = K_Constant_Token
        or else Table (Node_Id (N)).Kind = K_Token_Value
        or else Table (Node_Id (N)).Kind = K_Variable_Token
        or else Table (Node_Id (N)).Kind = K_Guard
        or else Table (Node_Id (N)).Kind = K_PN_Marking
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Include_Call
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node
        or else Table (Node_Id (N)).Kind = K_Subprogram_Declaration);

      return Node_Id (Table (Node_Id (N)).L (2));
   end Next_Node;

   procedure Set_Next_Node (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Node_Id
        or else Table (Node_Id (N)).Kind = K_Indirection
        or else Table (Node_Id (N)).Kind = K_Identifier
        or else Table (Node_Id (N)).Kind = K_Pn_Definition
        or else Table (Node_Id (N)).Kind = K_Scoped_Name
        or else Table (Node_Id (N)).Kind = K_Pn_Scope_Definition
        or else Table (Node_Id (N)).Kind = K_Position
        or else Table (Node_Id (N)).Kind = K_Color_Variable
        or else Table (Node_Id (N)).Kind = K_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Enumeration_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Domain_Declaration
        or else Table (Node_Id (N)).Kind = K_Variables_Declaration
        or else Table (Node_Id (N)).Kind = K_Symbolic_Value
        or else Table (Node_Id (N)).Kind = K_Constant_Token
        or else Table (Node_Id (N)).Kind = K_Token_Value
        or else Table (Node_Id (N)).Kind = K_Variable_Token
        or else Table (Node_Id (N)).Kind = K_Guard
        or else Table (Node_Id (N)).Kind = K_PN_Marking
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Include_Call
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node
        or else Table (Node_Id (N)).Kind = K_Subprogram_Declaration);

      Table (Node_Id (N)).L (2) := Int (V);
   end Set_Next_Node;

   function Item (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Indirection);

      return Node_Id (Table (Node_Id (N)).L (1));
   end Item;

   procedure Set_Item (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Indirection);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Item;

   function First_Node (N : List_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_List_Id);

      return Node_Id (Table (Node_Id (N)).L (1));
   end First_Node;

   procedure Set_First_Node (N : List_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_List_Id);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_First_Node;

   function Last_Node (N : List_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_List_Id);

      return Node_Id (Table (Node_Id (N)).L (2));
   end Last_Node;

   procedure Set_Last_Node (N : List_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_List_Id);

      Table (Node_Id (N)).L (2) := Int (V);
   end Set_Last_Node;

   function Name (N : Node_Id) return Name_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Identifier);

      return Name_Id (Table (Node_Id (N)).L (1));
   end Name;

   procedure Set_Name (N : Node_Id; V : Name_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Identifier);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Name;

   function Ocarina_Node (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Identifier);

      return Node_Id (Table (Node_Id (N)).L (3));
   end Ocarina_Node;

   procedure Set_Ocarina_Node (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Identifier);

      Table (Node_Id (N)).L (3) := Int (V);
   end Set_Ocarina_Node;

   function Corresponding_Entity (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Identifier);

      return Node_Id (Table (Node_Id (N)).L (4));
   end Corresponding_Entity;

   procedure Set_Corresponding_Entity (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Identifier);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Corresponding_Entity;

   function Identifier (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Pn_Definition
        or else Table (Node_Id (N)).Kind = K_Scoped_Name
        or else Table (Node_Id (N)).Kind = K_Pn_Scope_Definition
        or else Table (Node_Id (N)).Kind = K_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Enumeration_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Domain_Declaration
        or else Table (Node_Id (N)).Kind = K_Variables_Declaration
        or else Table (Node_Id (N)).Kind = K_Variable_Token
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (3));
   end Identifier;

   procedure Set_Identifier (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Pn_Definition
        or else Table (Node_Id (N)).Kind = K_Scoped_Name
        or else Table (Node_Id (N)).Kind = K_Pn_Scope_Definition
        or else Table (Node_Id (N)).Kind = K_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Enumeration_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration
        or else Table (Node_Id (N)).Kind = K_Domain_Declaration
        or else Table (Node_Id (N)).Kind = K_Variables_Declaration
        or else Table (Node_Id (N)).Kind = K_Variable_Token
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (3) := Int (V);
   end Set_Identifier;

   function Parent_Scoped_Name (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Scoped_Name);

      return Node_Id (Table (Node_Id (N)).L (1));
   end Parent_Scoped_Name;

   procedure Set_Parent_Scoped_Name (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Scoped_Name);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Parent_Scoped_Name;

   function Reference (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Scoped_Name);

      return Node_Id (Table (Node_Id (N)).L (4));
   end Reference;

   procedure Set_Reference (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Scoped_Name);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Reference;

   function Scoped_Name (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Pn_Scope_Definition
        or else Table (Node_Id (N)).Kind = K_Variable_Token
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (4));
   end Scoped_Name;

   procedure Set_Scoped_Name (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Pn_Scope_Definition
        or else Table (Node_Id (N)).Kind = K_Variable_Token
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Scoped_Name;

   function X_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Position);

      return Value_Id (Table (Node_Id (N)).L (1));
   end X_Value;

   procedure Set_X_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Position);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_X_Value;

   function Y_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Position);

      return Value_Id (Table (Node_Id (N)).L (3));
   end Y_Value;

   procedure Set_Y_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Position);

      Table (Node_Id (N)).L (3) := Int (V);
   end Set_Y_Value;

   function Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Color_Variable
        or else Table (Node_Id (N)).Kind = K_Constant_Token
        or else Table (Node_Id (N)).Kind = K_Guard);

      return Value_Id (Table (Node_Id (N)).L (1));
   end Value;

   procedure Set_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Color_Variable
        or else Table (Node_Id (N)).Kind = K_Constant_Token
        or else Table (Node_Id (N)).Kind = K_Guard);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Value;

   function First_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration);

      return Value_Id (Table (Node_Id (N)).L (1));
   end First_Value;

   procedure Set_First_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_First_Value;

   function Last_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration);

      return Value_Id (Table (Node_Id (N)).L (4));
   end Last_Value;

   procedure Set_Last_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Control_Color_Declaration);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Last_Value;

   function Symbolic_Values (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Enumeration_Class_Declaration);

      return List_Id (Table (Node_Id (N)).L (1));
   end Symbolic_Values;

   procedure Set_Symbolic_Values (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration
        or else Table (Node_Id (N)).Kind = K_Enumeration_Class_Declaration);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Symbolic_Values;

   function Default_Valid_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration);

      return Value_Id (Table (Node_Id (N)).L (4));
   end Default_Valid_Value;

   procedure Set_Default_Valid_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Default_Valid_Value;

   function Default_Invalid_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration);

      return Value_Id (Table (Node_Id (N)).L (5));
   end Default_Invalid_Value;

   procedure Set_Default_Invalid_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Data_Color_Declaration);

      Table (Node_Id (N)).L (5) := Int (V);
   end Set_Default_Invalid_Value;

   function Lower_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration);

      return Value_Id (Table (Node_Id (N)).L (1));
   end Lower_Value;

   procedure Set_Lower_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Lower_Value;

   function Higher_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration);

      return Value_Id (Table (Node_Id (N)).L (4));
   end Higher_Value;

   procedure Set_Higher_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Range_Class_Declaration);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Higher_Value;

   function Classes (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Domain_Declaration);

      return List_Id (Table (Node_Id (N)).L (1));
   end Classes;

   procedure Set_Classes (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Domain_Declaration);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Classes;

   function Variables (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Variables_Declaration);

      return List_Id (Table (Node_Id (N)).L (1));
   end Variables;

   procedure Set_Variables (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Variables_Declaration);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Variables;

   function Symbol_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Symbolic_Value);

      return Value_Id (Table (Node_Id (N)).L (1));
   end Symbol_Value;

   procedure Set_Symbol_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Symbolic_Value);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Symbol_Value;

   function Color_Variable (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Constant_Token);

      return Node_Id (Table (Node_Id (N)).L (3));
   end Color_Variable;

   procedure Set_Color_Variable (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Constant_Token);

      Table (Node_Id (N)).L (3) := Int (V);
   end Set_Color_Variable;

   function Number (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Constant_Token);

      return Value_Id (Table (Node_Id (N)).L (4));
   end Number;

   procedure Set_Number (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Constant_Token);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Number;

   function Constant_Token (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Token_Value);

      return List_Id (Table (Node_Id (N)).L (1));
   end Constant_Token;

   procedure Set_Constant_Token (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Token_Value);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Constant_Token;

   function Class (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Variable_Token);

      return Node_Id (Table (Node_Id (N)).L (1));
   end Class;

   procedure Set_Class (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Variable_Token);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Class;

   function Variable (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Guard);

      return Value_Id (Table (Node_Id (N)).L (3));
   end Variable;

   procedure Set_Variable (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Guard);

      Table (Node_Id (N)).L (3) := Int (V);
   end Set_Variable;

   function Operator (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Guard);

      return Value_Id (Table (Node_Id (N)).L (4));
   end Operator;

   procedure Set_Operator (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Guard);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_Operator;

   function Tokens (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_PN_Marking
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Port);

      return List_Id (Table (Node_Id (N)).L (5));
   end Tokens;

   procedure Set_Tokens (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_PN_Marking
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (5) := Int (V);
   end Set_Tokens;

   function Tuple (N : Node_Id) return Boolean is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_PN_Marking);

      return Boolean (Table (Node_Id (N)).B (1));
   end Tuple;

   procedure Set_Tuple (N : Node_Id; V : Boolean) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_PN_Marking);

      Table (Node_Id (N)).B (1) := Boolean (V);
   end Set_Tuple;

   function Color (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Port);

      return Node_Id (Table (Node_Id (N)).L (6));
   end Color;

   procedure Set_Color (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (6) := Int (V);
   end Set_Color;

   function Marking (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Port);

      return Node_Id (Table (Node_Id (N)).L (7));
   end Marking;

   procedure Set_Marking (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (7) := Int (V);
   end Set_Marking;

   function Position (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (8));
   end Position;

   procedure Set_Position (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Declaration
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration
        or else Table (Node_Id (N)).Kind = K_Port
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (8) := Int (V);
   end Set_Position;

   function Guards (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration);

      return List_Id (Table (Node_Id (N)).L (1));
   end Guards;

   procedure Set_Guards (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Transition_Declaration);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Guards;

   function First_Reference (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion);

      return Node_Id (Table (Node_Id (N)).L (1));
   end First_Reference;

   procedure Set_First_Reference (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_First_Reference;

   function Second_Reference (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion);

      return Node_Id (Table (Node_Id (N)).L (3));
   end Second_Reference;

   procedure Set_Second_Reference (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connect_Statement
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion);

      Table (Node_Id (N)).L (3) := Int (V);
   end Set_Second_Reference;

   function New_Scoped_Name (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion);

      return Node_Id (Table (Node_Id (N)).L (4));
   end New_Scoped_Name;

   procedure Set_New_Scoped_Name (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Place_Fusion
        or else Table (Node_Id (N)).Kind = K_Transition_Fusion);

      Table (Node_Id (N)).L (4) := Int (V);
   end Set_New_Scoped_Name;

   function Is_Event_Port (N : Node_Id) return Boolean is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return Boolean (Table (Node_Id (N)).B (1));
   end Is_Event_Port;

   procedure Set_Is_Event_Port (N : Node_Id; V : Boolean) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).B (1) := Boolean (V);
   end Set_Is_Event_Port;

   function Pop_Transition (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return Node_Id (Table (Node_Id (N)).L (9));
   end Pop_Transition;

   procedure Set_Pop_Transition (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (9) := Int (V);
   end Set_Pop_Transition;

   function Push_Transition (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return Node_Id (Table (Node_Id (N)).L (10));
   end Push_Transition;

   procedure Set_Push_Transition (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (10) := Int (V);
   end Set_Push_Transition;

   function Corresponding_Feature (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return Node_Id (Table (Node_Id (N)).L (11));
   end Corresponding_Feature;

   procedure Set_Corresponding_Feature (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (11) := Int (V);
   end Set_Corresponding_Feature;

   function Parent_Box (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return Node_Id (Table (Node_Id (N)).L (12));
   end Parent_Box;

   procedure Set_Parent_Box (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (12) := Int (V);
   end Set_Parent_Box;

   function Refered_Nodes (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return List_Id (Table (Node_Id (N)).L (13));
   end Refered_Nodes;

   procedure Set_Refered_Nodes (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (13) := Int (V);
   end Set_Refered_Nodes;

   function Thread_Color (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return Value_Id (Table (Node_Id (N)).L (14));
   end Thread_Color;

   procedure Set_Thread_Color (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (14) := Int (V);
   end Set_Thread_Color;

   function Thread_Reference (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      return Node_Id (Table (Node_Id (N)).L (15));
   end Thread_Reference;

   procedure Set_Thread_Reference (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Port);

      Table (Node_Id (N)).L (15) := Int (V);
   end Set_Thread_Reference;

   function Namespace_Scoped_Name (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Include_Call);

      return Node_Id (Table (Node_Id (N)).L (1));
   end Namespace_Scoped_Name;

   procedure Set_Namespace_Scoped_Name (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Include_Call);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Namespace_Scoped_Name;

   function Subprogram_Scoped_Name (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Include_Call);

      return Node_Id (Table (Node_Id (N)).L (3));
   end Subprogram_Scoped_Name;

   procedure Set_Subprogram_Scoped_Name (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Include_Call);

      Table (Node_Id (N)).L (3) := Int (V);
   end Set_Subprogram_Scoped_Name;

   function Include_Call (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (1));
   end Include_Call;

   procedure Set_Include_Call (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (1) := Int (V);
   end Set_Include_Call;

   function Places (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return List_Id (Table (Node_Id (N)).L (5));
   end Places;

   procedure Set_Places (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (5) := Int (V);
   end Set_Places;

   function Arcs (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return List_Id (Table (Node_Id (N)).L (6));
   end Arcs;

   procedure Set_Arcs (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Connection
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (6) := Int (V);
   end Set_Arcs;

   function Connections (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return List_Id (Table (Node_Id (N)).L (7));
   end Connections;

   procedure Set_Connections (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (7) := Int (V);
   end Set_Connections;

   function Place_Fusions (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return List_Id (Table (Node_Id (N)).L (9));
   end Place_Fusions;

   procedure Set_Place_Fusions (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (9) := Int (V);
   end Set_Place_Fusions;

   function Arc_Fusions (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return List_Id (Table (Node_Id (N)).L (10));
   end Arc_Fusions;

   procedure Set_Arc_Fusions (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (10) := Int (V);
   end Set_Arc_Fusions;

   function Subnets (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return List_Id (Table (Node_Id (N)).L (11));
   end Subnets;

   procedure Set_Subnets (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Container
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (11) := Int (V);
   end Set_Subnets;

   function Begin_Node (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (12));
   end Begin_Node;

   procedure Set_Begin_Node (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (12) := Int (V);
   end Set_Begin_Node;

   function End_Node (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (13));
   end End_Node;

   procedure Set_End_Node (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Functionnal_Entity
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (13) := Int (V);
   end Set_End_Node;

   function Reset_Transition (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (14));
   end Reset_Transition;

   procedure Set_Reset_Transition (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (14) := Int (V);
   end Set_Reset_Transition;

   function Body_Transition (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (15));
   end Body_Transition;

   procedure Set_Body_Transition (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (15) := Int (V);
   end Set_Body_Transition;

   function Ack_Receiver_Transition (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (16));
   end Ack_Receiver_Transition;

   procedure Set_Ack_Receiver_Transition (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (16) := Int (V);
   end Set_Ack_Receiver_Transition;

   function Ack_Receiver_Link (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (17));
   end Ack_Receiver_Link;

   procedure Set_Ack_Receiver_Link (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (17) := Int (V);
   end Set_Ack_Receiver_Link;

   function Ack_Place (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (18));
   end Ack_Place;

   procedure Set_Ack_Place (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (18) := Int (V);
   end Set_Ack_Place;

   function Ack_Link (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Node_Id (Table (Node_Id (N)).L (19));
   end Ack_Link;

   procedure Set_Ack_Link (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (19) := Int (V);
   end Set_Ack_Link;

   function Control_Color_Value (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return Value_Id (Table (Node_Id (N)).L (20));
   end Control_Color_Value;

   procedure Set_Control_Color_Value (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (20) := Int (V);
   end Set_Control_Color_Value;

   function Ports (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      return List_Id (Table (Node_Id (N)).L (21));
   end Ports;

   procedure Set_Ports (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Thread_Box);

      Table (Node_Id (N)).L (21) := Int (V);
   end Set_Ports;

   function Connection_Transition (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      return Node_Id (Table (Node_Id (N)).L (5));
   end Connection_Transition;

   procedure Set_Connection_Transition (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      Table (Node_Id (N)).L (5) := Int (V);
   end Set_Connection_Transition;

   function Source (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      return Node_Id (Table (Node_Id (N)).L (7));
   end Source;

   procedure Set_Source (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      Table (Node_Id (N)).L (7) := Int (V);
   end Set_Source;

   function Destinations (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      return List_Id (Table (Node_Id (N)).L (8));
   end Destinations;

   procedure Set_Destinations (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      Table (Node_Id (N)).L (8) := Int (V);
   end Set_Destinations;

   function Is_Event (N : Node_Id) return Boolean is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      return Boolean (Table (Node_Id (N)).B (1));
   end Is_Event;

   procedure Set_Is_Event (N : Node_Id; V : Boolean) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Connection);

      Table (Node_Id (N)).B (1) := Boolean (V);
   end Set_Is_Event;

   function Number_Of_Control_Vars (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Value_Id (Table (Node_Id (N)).L (12));
   end Number_Of_Control_Vars;

   procedure Set_Number_Of_Control_Vars (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (12) := Int (V);
   end Set_Number_Of_Control_Vars;

   function Number_Of_Value_Vars (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Value_Id (Table (Node_Id (N)).L (13));
   end Number_Of_Value_Vars;

   procedure Set_Number_Of_Value_Vars (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (13) := Int (V);
   end Set_Number_Of_Value_Vars;

   function Number_Of_Threads (N : Node_Id) return Value_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Value_Id (Table (Node_Id (N)).L (14));
   end Number_Of_Threads;

   procedure Set_Number_Of_Threads (N : Node_Id; V : Value_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (14) := Int (V);
   end Set_Number_Of_Threads;

   function Color_Declarations (N : Node_Id) return List_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return List_Id (Table (Node_Id (N)).L (15));
   end Color_Declarations;

   procedure Set_Color_Declarations (N : Node_Id; V : List_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (15) := Int (V);
   end Set_Color_Declarations;

   function Class_Control (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (16));
   end Class_Control;

   procedure Set_Class_Control (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (16) := Int (V);
   end Set_Class_Control;

   function Class_Value (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (17));
   end Class_Value;

   procedure Set_Class_Value (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (17) := Int (V);
   end Set_Class_Value;

   function Domain_Comm (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (18));
   end Domain_Comm;

   procedure Set_Domain_Comm (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (18) := Int (V);
   end Set_Domain_Comm;

   function Control_Variables (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (19));
   end Control_Variables;

   procedure Set_Control_Variables (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (19) := Int (V);
   end Set_Control_Variables;

   function Value_Variables (N : Node_Id) return Node_Id is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      return Node_Id (Table (Node_Id (N)).L (20));
   end Value_Variables;

   procedure Set_Value_Variables (N : Node_Id; V : Node_Id) is
   begin
      pragma Assert (False
        or else Table (Node_Id (N)).Kind = K_Root_Node);

      Table (Node_Id (N)).L (20) := Int (V);
   end Set_Value_Variables;

   procedure W_Node (N : Node_Id) is
   begin
      case Kind (N) is
         when K_Indirection =>
            W_Indirection
              (Node_Id (N));
         when K_Identifier =>
            W_Identifier
              (Node_Id (N));
         when K_Pn_Definition =>
            W_Pn_Definition
              (Node_Id (N));
         when K_Scoped_Name =>
            W_Scoped_Name
              (Node_Id (N));
         when K_Pn_Scope_Definition =>
            W_Pn_Scope_Definition
              (Node_Id (N));
         when K_Position =>
            W_Position
              (Node_Id (N));
         when K_Color_Variable =>
            W_Color_Variable
              (Node_Id (N));
         when K_Color_Declaration =>
            W_Color_Declaration
              (Node_Id (N));
         when K_Control_Color_Declaration =>
            W_Control_Color_Declaration
              (Node_Id (N));
         when K_Data_Color_Declaration =>
            W_Data_Color_Declaration
              (Node_Id (N));
         when K_Enumeration_Class_Declaration =>
            W_Enumeration_Class_Declaration
              (Node_Id (N));
         when K_Range_Class_Declaration =>
            W_Range_Class_Declaration
              (Node_Id (N));
         when K_Domain_Declaration =>
            W_Domain_Declaration
              (Node_Id (N));
         when K_Variables_Declaration =>
            W_Variables_Declaration
              (Node_Id (N));
         when K_Symbolic_Value =>
            W_Symbolic_Value
              (Node_Id (N));
         when K_Constant_Token =>
            W_Constant_Token
              (Node_Id (N));
         when K_Token_Value =>
            W_Token_Value
              (Node_Id (N));
         when K_Variable_Token =>
            W_Variable_Token
              (Node_Id (N));
         when K_Guard =>
            W_Guard
              (Node_Id (N));
         when K_PN_Marking =>
            W_PN_Marking
              (Node_Id (N));
         when K_Place_Declaration =>
            W_Place_Declaration
              (Node_Id (N));
         when K_Transition_Declaration =>
            W_Transition_Declaration
              (Node_Id (N));
         when K_Connect_Statement =>
            W_Connect_Statement
              (Node_Id (N));
         when K_Place_Fusion =>
            W_Place_Fusion
              (Node_Id (N));
         when K_Transition_Fusion =>
            W_Transition_Fusion
              (Node_Id (N));
         when K_Port =>
            W_Port
              (Node_Id (N));
         when K_Include_Call =>
            W_Include_Call
              (Node_Id (N));
         when K_Container =>
            W_Container
              (Node_Id (N));
         when K_Functionnal_Entity =>
            W_Functionnal_Entity
              (Node_Id (N));
         when K_Thread_Box =>
            W_Thread_Box
              (Node_Id (N));
         when K_Connection =>
            W_Connection
              (Node_Id (N));
         when K_Root_Node =>
            W_Root_Node
              (Node_Id (N));
         when K_Subprogram_Declaration =>
            W_Subprogram_Declaration
              (Node_Id (N));
         when others =>
            null;
      end case;
   end W_Node;

   procedure W_Indirection (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Item",
         "Node_Id",
         Image (Item (N)),
         Int (Item (N)));
   end W_Indirection;

   procedure W_Identifier (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Name",
         "Name_Id",
         Image (Name (N)));
      W_Node_Attribute
        ("Ocarina_Node",
         "Node_Id",
         Image (Ocarina_Node (N)),
         Int (Ocarina_Node (N)));
      W_Node_Attribute
        ("Corresponding_Entity",
         "Node_Id",
         Image (Corresponding_Entity (N)),
         Int (Corresponding_Entity (N)));
   end W_Identifier;

   procedure W_Pn_Definition (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
   end W_Pn_Definition;

   procedure W_Scoped_Name (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Parent_Scoped_Name",
         "Node_Id",
         Image (Parent_Scoped_Name (N)),
         Int (Parent_Scoped_Name (N)));
      W_Node_Attribute
        ("Reference",
         "Node_Id",
         Image (Reference (N)),
         Int (Reference (N)));
   end W_Scoped_Name;

   procedure W_Pn_Scope_Definition (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
   end W_Pn_Scope_Definition;

   procedure W_Position (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("X_Value",
         "Value_Id",
         Image (X_Value (N)));
      W_Node_Attribute
        ("Y_Value",
         "Value_Id",
         Image (Y_Value (N)));
   end W_Position;

   procedure W_Color_Variable (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Value",
         "Value_Id",
         Image (Value (N)));
   end W_Color_Variable;

   procedure W_Color_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
   end W_Color_Declaration;

   procedure W_Control_Color_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("First_Value",
         "Value_Id",
         Image (First_Value (N)));
      W_Node_Attribute
        ("Last_Value",
         "Value_Id",
         Image (Last_Value (N)));
   end W_Control_Color_Declaration;

   procedure W_Data_Color_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Symbolic_Values",
         "List_Id",
         Image (Symbolic_Values (N)),
         Int (Symbolic_Values (N)));
      W_Node_Attribute
        ("Default_Valid_Value",
         "Value_Id",
         Image (Default_Valid_Value (N)));
      W_Node_Attribute
        ("Default_Invalid_Value",
         "Value_Id",
         Image (Default_Invalid_Value (N)));
   end W_Data_Color_Declaration;

   procedure W_Enumeration_Class_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Symbolic_Values",
         "List_Id",
         Image (Symbolic_Values (N)),
         Int (Symbolic_Values (N)));
   end W_Enumeration_Class_Declaration;

   procedure W_Range_Class_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Lower_Value",
         "Value_Id",
         Image (Lower_Value (N)));
      W_Node_Attribute
        ("Higher_Value",
         "Value_Id",
         Image (Higher_Value (N)));
   end W_Range_Class_Declaration;

   procedure W_Domain_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Classes",
         "List_Id",
         Image (Classes (N)),
         Int (Classes (N)));
   end W_Domain_Declaration;

   procedure W_Variables_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Variables",
         "List_Id",
         Image (Variables (N)),
         Int (Variables (N)));
   end W_Variables_Declaration;

   procedure W_Symbolic_Value (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Symbol_Value",
         "Value_Id",
         Image (Symbol_Value (N)));
   end W_Symbolic_Value;

   procedure W_Constant_Token (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Value",
         "Value_Id",
         Image (Value (N)));
      W_Node_Attribute
        ("Color_Variable",
         "Node_Id",
         Image (Color_Variable (N)),
         Int (Color_Variable (N)));
      W_Node_Attribute
        ("Number",
         "Value_Id",
         Image (Number (N)));
   end W_Constant_Token;

   procedure W_Token_Value (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Constant_Token",
         "List_Id",
         Image (Constant_Token (N)),
         Int (Constant_Token (N)));
   end W_Token_Value;

   procedure W_Variable_Token (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Class",
         "Node_Id",
         Image (Class (N)),
         Int (Class (N)));
   end W_Variable_Token;

   procedure W_Guard (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Value",
         "Value_Id",
         Image (Value (N)));
      W_Node_Attribute
        ("Variable",
         "Value_Id",
         Image (Variable (N)));
      W_Node_Attribute
        ("Operator",
         "Value_Id",
         Image (Operator (N)));
   end W_Guard;

   procedure W_PN_Marking (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Tokens",
         "List_Id",
         Image (Tokens (N)),
         Int (Tokens (N)));
      W_Node_Attribute
        ("Tuple",
         "Boolean",
         Image (Tuple (N)));
   end W_PN_Marking;

   procedure W_Place_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Tokens",
         "List_Id",
         Image (Tokens (N)),
         Int (Tokens (N)));
      W_Node_Attribute
        ("Color",
         "Node_Id",
         Image (Color (N)),
         Int (Color (N)));
      W_Node_Attribute
        ("Marking",
         "Node_Id",
         Image (Marking (N)),
         Int (Marking (N)));
      W_Node_Attribute
        ("Position",
         "Node_Id",
         Image (Position (N)),
         Int (Position (N)));
   end W_Place_Declaration;

   procedure W_Transition_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Position",
         "Node_Id",
         Image (Position (N)),
         Int (Position (N)));
      W_Node_Attribute
        ("Guards",
         "List_Id",
         Image (Guards (N)),
         Int (Guards (N)));
   end W_Transition_Declaration;

   procedure W_Connect_Statement (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Marking",
         "Node_Id",
         Image (Marking (N)),
         Int (Marking (N)));
      W_Node_Attribute
        ("First_Reference",
         "Node_Id",
         Image (First_Reference (N)),
         Int (First_Reference (N)));
      W_Node_Attribute
        ("Second_Reference",
         "Node_Id",
         Image (Second_Reference (N)),
         Int (Second_Reference (N)));
   end W_Connect_Statement;

   procedure W_Place_Fusion (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("First_Reference",
         "Node_Id",
         Image (First_Reference (N)),
         Int (First_Reference (N)));
      W_Node_Attribute
        ("Second_Reference",
         "Node_Id",
         Image (Second_Reference (N)),
         Int (Second_Reference (N)));
      W_Node_Attribute
        ("New_Scoped_Name",
         "Node_Id",
         Image (New_Scoped_Name (N)),
         Int (New_Scoped_Name (N)));
   end W_Place_Fusion;

   procedure W_Transition_Fusion (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("First_Reference",
         "Node_Id",
         Image (First_Reference (N)),
         Int (First_Reference (N)));
      W_Node_Attribute
        ("Second_Reference",
         "Node_Id",
         Image (Second_Reference (N)),
         Int (Second_Reference (N)));
      W_Node_Attribute
        ("New_Scoped_Name",
         "Node_Id",
         Image (New_Scoped_Name (N)),
         Int (New_Scoped_Name (N)));
   end W_Transition_Fusion;

   procedure W_Port (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Tokens",
         "List_Id",
         Image (Tokens (N)),
         Int (Tokens (N)));
      W_Node_Attribute
        ("Color",
         "Node_Id",
         Image (Color (N)),
         Int (Color (N)));
      W_Node_Attribute
        ("Marking",
         "Node_Id",
         Image (Marking (N)),
         Int (Marking (N)));
      W_Node_Attribute
        ("Position",
         "Node_Id",
         Image (Position (N)),
         Int (Position (N)));
      W_Node_Attribute
        ("Is_Event_Port",
         "Boolean",
         Image (Is_Event_Port (N)));
      W_Node_Attribute
        ("Pop_Transition",
         "Node_Id",
         Image (Pop_Transition (N)),
         Int (Pop_Transition (N)));
      W_Node_Attribute
        ("Push_Transition",
         "Node_Id",
         Image (Push_Transition (N)),
         Int (Push_Transition (N)));
      W_Node_Attribute
        ("Corresponding_Feature",
         "Node_Id",
         Image (Corresponding_Feature (N)),
         Int (Corresponding_Feature (N)));
      W_Node_Attribute
        ("Parent_Box",
         "Node_Id",
         Image (Parent_Box (N)),
         Int (Parent_Box (N)));
      W_Node_Attribute
        ("Refered_Nodes",
         "List_Id",
         Image (Refered_Nodes (N)),
         Int (Refered_Nodes (N)));
      W_Node_Attribute
        ("Thread_Color",
         "Value_Id",
         Image (Thread_Color (N)));
      W_Node_Attribute
        ("Thread_Reference",
         "Node_Id",
         Image (Thread_Reference (N)),
         Int (Thread_Reference (N)));
   end W_Port;

   procedure W_Include_Call (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Namespace_Scoped_Name",
         "Node_Id",
         Image (Namespace_Scoped_Name (N)),
         Int (Namespace_Scoped_Name (N)));
      W_Node_Attribute
        ("Subprogram_Scoped_Name",
         "Node_Id",
         Image (Subprogram_Scoped_Name (N)),
         Int (Subprogram_Scoped_Name (N)));
   end W_Include_Call;

   procedure W_Container (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Position",
         "Node_Id",
         Image (Position (N)),
         Int (Position (N)));
      W_Node_Attribute
        ("Include_Call",
         "Node_Id",
         Image (Include_Call (N)),
         Int (Include_Call (N)));
      W_Node_Attribute
        ("Places",
         "List_Id",
         Image (Places (N)),
         Int (Places (N)));
      W_Node_Attribute
        ("Arcs",
         "List_Id",
         Image (Arcs (N)),
         Int (Arcs (N)));
      W_Node_Attribute
        ("Connections",
         "List_Id",
         Image (Connections (N)),
         Int (Connections (N)));
      W_Node_Attribute
        ("Place_Fusions",
         "List_Id",
         Image (Place_Fusions (N)),
         Int (Place_Fusions (N)));
      W_Node_Attribute
        ("Arc_Fusions",
         "List_Id",
         Image (Arc_Fusions (N)),
         Int (Arc_Fusions (N)));
      W_Node_Attribute
        ("Subnets",
         "List_Id",
         Image (Subnets (N)),
         Int (Subnets (N)));
   end W_Container;

   procedure W_Functionnal_Entity (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Position",
         "Node_Id",
         Image (Position (N)),
         Int (Position (N)));
      W_Node_Attribute
        ("Include_Call",
         "Node_Id",
         Image (Include_Call (N)),
         Int (Include_Call (N)));
      W_Node_Attribute
        ("Places",
         "List_Id",
         Image (Places (N)),
         Int (Places (N)));
      W_Node_Attribute
        ("Arcs",
         "List_Id",
         Image (Arcs (N)),
         Int (Arcs (N)));
      W_Node_Attribute
        ("Connections",
         "List_Id",
         Image (Connections (N)),
         Int (Connections (N)));
      W_Node_Attribute
        ("Place_Fusions",
         "List_Id",
         Image (Place_Fusions (N)),
         Int (Place_Fusions (N)));
      W_Node_Attribute
        ("Arc_Fusions",
         "List_Id",
         Image (Arc_Fusions (N)),
         Int (Arc_Fusions (N)));
      W_Node_Attribute
        ("Subnets",
         "List_Id",
         Image (Subnets (N)),
         Int (Subnets (N)));
      W_Node_Attribute
        ("Begin_Node",
         "Node_Id",
         Image (Begin_Node (N)),
         Int (Begin_Node (N)));
      W_Node_Attribute
        ("End_Node",
         "Node_Id",
         Image (End_Node (N)),
         Int (End_Node (N)));
   end W_Functionnal_Entity;

   procedure W_Thread_Box (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Position",
         "Node_Id",
         Image (Position (N)),
         Int (Position (N)));
      W_Node_Attribute
        ("Include_Call",
         "Node_Id",
         Image (Include_Call (N)),
         Int (Include_Call (N)));
      W_Node_Attribute
        ("Places",
         "List_Id",
         Image (Places (N)),
         Int (Places (N)));
      W_Node_Attribute
        ("Arcs",
         "List_Id",
         Image (Arcs (N)),
         Int (Arcs (N)));
      W_Node_Attribute
        ("Connections",
         "List_Id",
         Image (Connections (N)),
         Int (Connections (N)));
      W_Node_Attribute
        ("Place_Fusions",
         "List_Id",
         Image (Place_Fusions (N)),
         Int (Place_Fusions (N)));
      W_Node_Attribute
        ("Arc_Fusions",
         "List_Id",
         Image (Arc_Fusions (N)),
         Int (Arc_Fusions (N)));
      W_Node_Attribute
        ("Subnets",
         "List_Id",
         Image (Subnets (N)),
         Int (Subnets (N)));
      W_Node_Attribute
        ("Begin_Node",
         "Node_Id",
         Image (Begin_Node (N)),
         Int (Begin_Node (N)));
      W_Node_Attribute
        ("End_Node",
         "Node_Id",
         Image (End_Node (N)),
         Int (End_Node (N)));
      W_Node_Attribute
        ("Reset_Transition",
         "Node_Id",
         Image (Reset_Transition (N)),
         Int (Reset_Transition (N)));
      W_Node_Attribute
        ("Body_Transition",
         "Node_Id",
         Image (Body_Transition (N)),
         Int (Body_Transition (N)));
      W_Node_Attribute
        ("Ack_Receiver_Transition",
         "Node_Id",
         Image (Ack_Receiver_Transition (N)),
         Int (Ack_Receiver_Transition (N)));
      W_Node_Attribute
        ("Ack_Receiver_Link",
         "Node_Id",
         Image (Ack_Receiver_Link (N)),
         Int (Ack_Receiver_Link (N)));
      W_Node_Attribute
        ("Ack_Place",
         "Node_Id",
         Image (Ack_Place (N)),
         Int (Ack_Place (N)));
      W_Node_Attribute
        ("Ack_Link",
         "Node_Id",
         Image (Ack_Link (N)),
         Int (Ack_Link (N)));
      W_Node_Attribute
        ("Control_Color_Value",
         "Value_Id",
         Image (Control_Color_Value (N)));
      W_Node_Attribute
        ("Ports",
         "List_Id",
         Image (Ports (N)),
         Int (Ports (N)));
   end W_Thread_Box;

   procedure W_Connection (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Arcs",
         "List_Id",
         Image (Arcs (N)),
         Int (Arcs (N)));
      W_Node_Attribute
        ("Connection_Transition",
         "Node_Id",
         Image (Connection_Transition (N)),
         Int (Connection_Transition (N)));
      W_Node_Attribute
        ("Source",
         "Node_Id",
         Image (Source (N)),
         Int (Source (N)));
      W_Node_Attribute
        ("Destinations",
         "List_Id",
         Image (Destinations (N)),
         Int (Destinations (N)));
      W_Node_Attribute
        ("Is_Event",
         "Boolean",
         Image (Is_Event (N)));
   end W_Connection;

   procedure W_Root_Node (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
      W_Node_Attribute
        ("Identifier",
         "Node_Id",
         Image (Identifier (N)),
         Int (Identifier (N)));
      W_Node_Attribute
        ("Scoped_Name",
         "Node_Id",
         Image (Scoped_Name (N)),
         Int (Scoped_Name (N)));
      W_Node_Attribute
        ("Position",
         "Node_Id",
         Image (Position (N)),
         Int (Position (N)));
      W_Node_Attribute
        ("Include_Call",
         "Node_Id",
         Image (Include_Call (N)),
         Int (Include_Call (N)));
      W_Node_Attribute
        ("Places",
         "List_Id",
         Image (Places (N)),
         Int (Places (N)));
      W_Node_Attribute
        ("Arcs",
         "List_Id",
         Image (Arcs (N)),
         Int (Arcs (N)));
      W_Node_Attribute
        ("Connections",
         "List_Id",
         Image (Connections (N)),
         Int (Connections (N)));
      W_Node_Attribute
        ("Place_Fusions",
         "List_Id",
         Image (Place_Fusions (N)),
         Int (Place_Fusions (N)));
      W_Node_Attribute
        ("Arc_Fusions",
         "List_Id",
         Image (Arc_Fusions (N)),
         Int (Arc_Fusions (N)));
      W_Node_Attribute
        ("Subnets",
         "List_Id",
         Image (Subnets (N)),
         Int (Subnets (N)));
      W_Node_Attribute
        ("Number_Of_Control_Vars",
         "Value_Id",
         Image (Number_Of_Control_Vars (N)));
      W_Node_Attribute
        ("Number_Of_Value_Vars",
         "Value_Id",
         Image (Number_Of_Value_Vars (N)));
      W_Node_Attribute
        ("Number_Of_Threads",
         "Value_Id",
         Image (Number_Of_Threads (N)));
      W_Node_Attribute
        ("Color_Declarations",
         "List_Id",
         Image (Color_Declarations (N)),
         Int (Color_Declarations (N)));
      W_Node_Attribute
        ("Class_Control",
         "Node_Id",
         Image (Class_Control (N)),
         Int (Class_Control (N)));
      W_Node_Attribute
        ("Class_Value",
         "Node_Id",
         Image (Class_Value (N)),
         Int (Class_Value (N)));
      W_Node_Attribute
        ("Domain_Comm",
         "Node_Id",
         Image (Domain_Comm (N)),
         Int (Domain_Comm (N)));
      W_Node_Attribute
        ("Control_Variables",
         "Node_Id",
         Image (Control_Variables (N)),
         Int (Control_Variables (N)));
      W_Node_Attribute
        ("Value_Variables",
         "Node_Id",
         Image (Value_Variables (N)),
         Int (Value_Variables (N)));
   end W_Root_Node;

   procedure W_Subprogram_Declaration (N : Node_Id) is
   begin
      W_Node_Header
        (Node_Id (N));
      W_Node_Attribute
        ("Next_Node",
         "Node_Id",
         Image (Next_Node (N)),
         Int (Next_Node (N)));
   end W_Subprogram_Declaration;

end Ocarina.PN.Nodes;
