------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                      O C A R I N A . P N . R O O T                       --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                 Copyright (C) 2006, GET-Telecom Paris.                   --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Types;
with Ocarina.AADL_Values;

package Ocarina.PN.Root is

   procedure Create_PN_Declarations (PN_Root : Types.Node_Id);
   --  Set all the variables and color declarations

   function Make_Root_Node return Types.Node_Id;
   --  Create the root node

   function Declare_New_Thread
     (PN_Root : Types.Node_Id)
     return Ocarina.AADL_Values.Value_Type;
   --  return a new number for a thread, used to set token value

   function Get_New_Value_Variable
     (PN_Root, Current_Variable : Types.Node_Id)
     return Types.Node_Id;

   function Get_New_Control_Variable
     (PN_Root, Current_Variable : Types.Node_Id)
     return Types.Node_Id;

end Ocarina.PN.Root;
