------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                           O C A R I N A . P N                            --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2006-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

--  This package generates a pn tree

with Types;

package Ocarina.PN is

   type PN_Options is record
      Output_Directory : Types.Name_Id;
   end record;

   Default_PN_Options : PN_Options;

   function Create_Petri_Net
     (Root : Types.Node_Id;
      Options : PN_Options := Default_PN_Options)
     return Boolean;

   procedure Init;
   --  Initializes the PN module

   procedure Reset;
   --  Resets the PN module

private
   Separator : Types.Name_Id;
   Dispatch_Property : Types.Name_Id;
   Background_Dispatch : Types.Name_Id;
   Guard_Unequality : Types.Value_Id;
   Guard_Equality : Types.Value_Id;
   Undefined_Value_Variable : Types.Name_Id;

   type Node_Location is record
      X : Natural;
      Y : Natural;
   end record;
   --  A structure to describe both node location & container extrema
   --  positions

end Ocarina.PN;
